﻿namespace TorrentHarvester
{
    using System;
    using System.Windows.Forms;

    public class CColumn
    {
        private CField.EFieldType _Type;
        public int Count;
        public string Name;
        public int Width;

        public CColumn()
        {
            this._Type = CField.EFieldType.ftText;
            this.Count = 0;
        }

        public CColumn(string strName)
        {
            this._Type = CField.EFieldType.ftText;
            this.Name = strName;
            this.Count = 0;
            this.Width = 70;
        }

        public HorizontalAlignment Alignment
        {
            get
            {
                HorizontalAlignment alignment = new HorizontalAlignment();
                switch (this.Type)
                {
                    case CField.EFieldType.ftText:
                        return HorizontalAlignment.Left;

                    case CField.EFieldType.ftNumber:
                        return HorizontalAlignment.Right;

                    case CField.EFieldType.ftFilesize:
                        return HorizontalAlignment.Right;

                    case CField.EFieldType.ftDate:
                        return HorizontalAlignment.Left;
                }
                return alignment;
            }
        }

        public string Key
        {
            get
            {
                return (this.Name + ((int) this.Type).ToString());
            }
        }

        public CField.EFieldType Type
        {
            get
            {
                return this._Type;
            }
            set
            {
                this._Type = value;
            }
        }

        public string TypeString
        {
            get
            {
                string str = "";
                switch (this._Type)
                {
                    case CField.EFieldType.ftText:
                        return "Text";

                    case CField.EFieldType.ftNumber:
                        return "Number";

                    case CField.EFieldType.ftFilesize:
                        return "Filesize";

                    case CField.EFieldType.ftDate:
                        return "Date";
                }
                return str;
            }
            set
            {
                string sLeft = value;
                if (String.Compare(sLeft, "Text", false) == 0)
                {
                    this._Type = CField.EFieldType.ftText;
                }
                else if (String.Compare(sLeft, "Number", false) == 0)
                {
                    this._Type = CField.EFieldType.ftNumber;
                }
                else if (String.Compare(sLeft, "Filesize", false) == 0)
                {
                    this._Type = CField.EFieldType.ftFilesize;
                }
                else if (String.Compare(sLeft, "Date", false) == 0)
                {
                    this._Type = CField.EFieldType.ftDate;
                }
            }
        }
    }
}

