﻿namespace TorrentHarvester
{
    using System;
    using Microsoft.VisualBasic.CompilerServices;
    using Microsoft.VisualBasic;

    public class CCookie
    {
        public EBrowserType BrowserType;
        public DateTime Created;
        public string Domain;
        public DateTime Expire;
        public string Filename;
        public string Name;
        public string Raw;
        public string Scope;
        public bool Secure;
        public string Value;

        public CCookie(string strCookie, string strFilename, EBrowserType nBrowserType)
        {
            this.BrowserType = nBrowserType;
            this.Raw = strCookie;
            this.Filename = strFilename;
            switch (nBrowserType)
            {
                case EBrowserType.btMSIE:
                    this.ParseMSIE();
                    break;

                case EBrowserType.btNetscape:
                case EBrowserType.btFireFox:
                    this.ParseFFNS();
                    break;
            }
        }

        private DateTime GetFirefoxDate(string strDate)
        {
            long num;
            DateTime time;
            try
            {
                num = long.Parse(strDate);
                time = new DateTime(num);
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                DateTime.TryParse(strDate, out time);
                ProjectData.ClearProjectError();
            }
            return time;
        }

        private DateTime GetMSIEDate(string strDateLo, string strDateHi)
        {
            DateTime time = new DateTime();
            try
            {
                time = DateTime.FromFileTime((0x100000000L * LongType.FromString(strDateHi)) + LongType.FromString(strDateLo));
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                ProjectData.ClearProjectError();
            }
            return time;
        }

        private DateTime GetNetscapeDate(string strDate)
        {
            DateTime time = new DateTime();
            try
            {
                int num7 = IntegerType.FromString(strDate);
                int num8 = num7 & 0x2000ffff;
                num8 &= -2147418113;
                int num9 = (int) Math.Round((double) (((double) ((short) (num7 & -65536))) / 65536.0));
                int day = num9 & -2147483617;
                int month = (int) Math.Round((double) (((double) ((short) (num9 & -2147483168))) / 32.0));
                int year = (int) Math.Round((double) ((((double) ((short) (num9 & -2147418624))) / 512.0) + 1980.0));
                int second = ((short) (num8 & -2147483617)) * 2;
                int minute = (int) Math.Round((double) (((double) ((short) (num8 & -2147481632))) / 32.0));
                int hour = (int) Math.Round((double) (((double) ((short) (num8 & -2147420160))) / 2048.0));
                time = DateTime.FromOADate(DateAndTime.DateSerial(year, month, day).ToOADate() + DateAndTime.TimeSerial(hour, minute, second).ToOADate());
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                ProjectData.ClearProjectError();
            }
            return time;
        }

        private void ParseFFNS()
        {
            string[] strArray = Strings.Split(this.Raw.Trim(), "\t", -1, CompareMethod.Binary);
            this.Domain = strArray[0];
            if (this.Domain.StartsWith("."))
            {
                this.Domain = this.Domain.Substring(1);
            }
            this.Domain = this.Domain + strArray[2];
            string str2 = Interaction.IIf(StringType.StrCmp(strArray[1], "TRUE", false) == 0, "Domain", "Host").ToString();
            this.Secure = StringType.StrCmp(strArray[3], "FALSE", false) != 0;
            if ((this.BrowserType == EBrowserType.btNetscape) && (LongType.FromString(strArray[4]) < 0x7fffffffL))
            {
                this.Expire = this.GetNetscapeDate(strArray[4]);
            }
            else
            {
                this.Expire = this.GetFirefoxDate(strArray[4]);
            }
            this.Name = strArray[5];
            this.Value = strArray[6];
        }

        private void ParseMSIE()
        {
            string[] strArray = Strings.Split(this.Raw.Trim(), "\n", -1, CompareMethod.Binary);
            this.Name = strArray[0];
            this.Value = strArray[1];
            this.Domain = strArray[2];
            this.Secure = StringType.StrCmp(strArray[3], "0", false) != 0;
            this.Expire = this.GetMSIEDate(strArray[4], strArray[5]);
            this.Created = this.GetMSIEDate(strArray[6], strArray[7]);
        }

        public string CookieString
        {
            get
            {
                return (this.Name + "=" + this.Value);
            }
        }

        public string Key
        {
            get
            {
                return (this.Domain + " " + this.Name);
            }
        }

        public enum EBrowserType
        {
            btMSIE,
            btNetscape,
            btFireFox
        }
    }
}

