﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using Microsoft.VisualBasic.CompilerServices;
    using System;
    using System.Collections;
    using System.IO;

    public class CCookies
    {
        public Collection Cookies;
        public Collection Folders = new Collection();

        private void FetchMSIECookies(string strFolder)
        {
            for (string str2 = FileSystem.Dir(strFolder + @"\*@*.txt", FileAttribute.Normal); StringType.StrCmp(str2, "", false) != 0; str2 = FileSystem.Dir())
            {
                string str3;
                try
                {
                    StreamReader reader = new StreamReader(strFolder + @"\" + str2);
                    str3 = reader.ReadToEnd().Trim();
                    reader.Close();
                }
                catch (Exception exception1)
                {
                    ProjectData.SetProjectError(exception1);
                    str3 = "";
                    ProjectData.ClearProjectError();
                }
                foreach (string str in Strings.Split(str3, "\n*\n", -1, CompareMethod.Binary))
                {
                    try
                    {
                        CCookie item = new CCookie(str, str2, CCookie.EBrowserType.btMSIE);
                        this.Cookies.Add(item, item.Key, null, null);
                    }
                    catch (Exception exception2)
                    {
                        ProjectData.SetProjectError(exception2);
                        ProjectData.ClearProjectError();
                    }
                }
            }
        }

        private void FetchNSCookies(string strFolder)
        {
            string path = strFolder + @"\cookies.txt";
            if (File.Exists(path))
            {
                CCookie.EBrowserType btFireFox;
                StreamReader reader = new StreamReader(path);
                string expression = reader.ReadToEnd().Trim();
                reader.Close();
                if (expression.StartsWith("# HTTP Cookie File"))
                {
                    btFireFox = CCookie.EBrowserType.btFireFox;
                }
                else if (expression.StartsWith("# Netscape HTTP Cookie"))
                {
                    btFireFox = CCookie.EBrowserType.btNetscape;
                }
                else
                {
                    btFireFox = CCookie.EBrowserType.btMSIE;
                }
                if (btFireFox != CCookie.EBrowserType.btMSIE)
                {
                    foreach (string str in Strings.Split(expression, "\n", -1, CompareMethod.Binary))
                    {
                        String temp = str;
                        while (temp.EndsWith("\r") | temp.EndsWith("\n"))
                        {
                            temp = temp.Substring(0, temp.Length - 1);
                        }
                        if ((temp.Length > 0) && !temp.StartsWith("#"))
                        {
                            try
                            {
                                CCookie item = new CCookie(str, "cookies.txt", btFireFox);
                                this.Cookies.Add(item, item.Key, null, null);
                            }
                            catch (Exception exception1)
                            {
                                ProjectData.SetProjectError(exception1);
                                ProjectData.ClearProjectError();
                            }
                        }
                    }
                }
            }
        }

        public string GetCookie(string strDomain)
        {
            string sLeft = "";
            foreach (CCookie cookie in this.Cookies)
            {
                if (StringType.StrCmp(cookie.Domain, strDomain, false) == 0)
                {
                    if (StringType.StrCmp(sLeft, "", false) != 0)
                    {
                        sLeft = sLeft + "; ";
                    }
                    sLeft = sLeft + cookie.Name + "=" + cookie.Value;
                }
            }
            return sLeft;
        }

        public void GetFolders()
        {
            string str;
            this.Folders = new Collection();
            this.Folders.Add(Environment.GetFolderPath(Environment.SpecialFolder.Cookies), null, null, null);
            string folderPath = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData);
            if (StringType.StrCmp(folderPath, "", false) != 0)
            {
                folderPath = folderPath + @"\Mozilla\FireFox\Profiles\";
                for (str = FileSystem.Dir(folderPath, FileAttribute.Directory); StringType.StrCmp(str, "", false) != 0; str = FileSystem.Dir())
                {
                    this.Folders.Add(folderPath + str, null, null, null);
                }
            }
            folderPath = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData);
            if (StringType.StrCmp(folderPath, "", false) != 0)
            {
                folderPath = folderPath + @"\Netscape\NSB\Profiles\";
                for (str = FileSystem.Dir(folderPath, FileAttribute.Directory); StringType.StrCmp(str, "", false) != 0; str = FileSystem.Dir())
                {
                    this.Folders.Add(folderPath + str, null, null, null);
                }
            }
        }

        public void Rescan()
        {
            IEnumerator enumerator = null;
            this.Cookies = new Collection();
            this.FetchMSIECookies(modGlobal.g_oSettings.SelectedCookieFolder);
            this.FetchNSCookies(modGlobal.g_oSettings.SelectedCookieFolder);
            try
            {
                enumerator = modGlobal.Engines.GetEnumerator();
                while (enumerator.MoveNext())
                {
                    CEngine current = (CEngine) enumerator.Current;
                    if (current.Login != null)
                    {
                        current.Login.Cookie = this.GetCookie(current.Login.Domain);
                    }
                }
            }
            finally
            {
                if (enumerator is IDisposable)
                {
                    ((IDisposable) enumerator).Dispose();
                }
            }
        }
    }
}

