﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using Microsoft.VisualBasic.CompilerServices;
    using System;
    using System.Collections;
    using System.Data;
    using System.IO;
    using System.Runtime.CompilerServices;
    using System.Runtime.InteropServices;
    using System.Threading;

    public class CEngine
    {
        private string _strFilename;
        public Collection AllFields = new Collection();
        public string Bounder = "";
        public string Category = "";
        public string CurrentSearchText;
        public CTextTransforms DataFind = new CTextTransforms();
        public EDataType DataType = EDataType.dtTable;
        public CRow DefaultRow;
        public string Delimiter = "";
        public int DiscardedCount;
        public DateTime EngineDate = new DateTime(0x8aab5b7044c8000L);
        public bool Expanded;
        public Collection Files;
        public string HomePage = "";
        public bool IncludeRowTag;
        public bool IsCurrentNoSave;
        private const string Key_Data = "data";
        private const string Key_Data_Bounder = "bounder";
        private const string Key_Data_DataFind = "datafind";
        private const string Key_Data_Delimiter = "delimiter";
        private const string Key_Data_IncludeRowTag = "includerowtag";
        private const string Key_Data_Line_Break = "linebreak";
        private const string Key_Data_SkipHeader = "skipheader";
        private const string Key_Data_TableFind = "tablefind";
        private const string Key_Data_TableSkip = "tableskip";
        private const string Key_Data_Type = "type";
        private const string Key_Data_Type_Delimited = "delimited";
        private const string Key_Data_Type_Table = "table";
        private const string Key_Engine = "engine";
        private const string Key_Engine_Category = "category";
        private const string Key_Engine_Version = "version";
        private const string Key_General = "general";
        private const string Key_General_Date = "date";
        private const string Key_General_HomePage = "homepage";
        private const string Key_General_ToolTip = "tooltip";
        private const string Key_Login = "login";
        private const string Key_Menu = "action";
        private const string Key_Pages = "pages";
        private const string Key_Pages_NextPage = "nextpage";
        private const string Key_Pages_PageIdent = "pageident";
        private const string Key_Pages_SearchDelimiter = "searchdelimiter";
        private const string Key_Pages_SearchPage = "searchpage";
        private const string Key_Pages_Type = "type";
        private const string Key_Pages_Type_NextPageURL = "nextpageurl";
        private const string Key_Pages_Type_PageNumber = "pagenumber";
        private const string Key_Pages_Type_SinglePage = "singlepage";
        private const string Key_Pages_Type_Static = "static";
        private const string Key_Pages_Zerobased = "zerobased";
        private const string Key_Row = "row";
        public string LineBreak = "";
        public CLogin Login;
        public Collection Menus = new Collection();
        public string Name;
        public string NextPage = "";
        public Collection Pages;
        public CTextTransforms PagesTransforms = new CTextTransforms();
        public EPageType PageType = EPageType.ptSingle;
        public Collection Rows = new Collection();
        public string SearchDelimiter = "+";
        public string SearchPage = "";
        public int SkipHeader;
        public EEngineStatus Status = EEngineStatus.esOK;
        public StructTableFind TableFind = new StructTableFind();
        public string ToolTip = "";
        public string Version = "";
        public bool ZeroBasedPages;

        public event EngineStatusChangedEventHandler EngineStatusChanged;

        public event FileStatusChangedEventHandler FileStatusChanged;

        public event PageStatusChangedEventHandler PageStatusChanged;

        public CEngine(string strName)
        {
            this.Name = strName;
            this.Init();
        }

        public void AddField(CField oField)
        {
            this.AllFields.Add(oField, oField.GlobalKey, null, null);
            oField.Row.Fields.Add(oField, oField.RowKey, null, null);
        }

        public CPage AddPage(string strURL)
        {
            if (this.Pages == null)
            {
                this.Pages = new Collection();
            }
            CPage item = new CPage();
            item.Engine = this;
            item.URL = strURL;
            item.Index = this.Pages.Count + 1;
            this.Pages.Add(item, item.Key, null, null);
            return item;
        }

        public bool BelongsToCategory(string strCategory)
        {
            bool flag = false;
            if (StringType.StrCmp(strCategory, "", false) == 0)
            {
                flag = true;
            }
            foreach (string str in this.Categories())
            {
                if (StringType.StrCmp(str, strCategory, false) == 0)
                {
                    flag = true;
                }
            }
            return flag;
        }

        public string[] Categories()
        {
            return Strings.Split(this.Category, ";", -1, CompareMethod.Binary);
        }

        public void Delete()
        {
            try
            {
                this.Version = "0";
                File.Delete(modGlobal.EnginesFolder + "Engine - " + this.Name + ".xml");
                for (string str = FileSystem.Dir(modGlobal.DesignerCacheFolder + modGlobal.g_oStrings.FixFilename(this.Name) + "*.csh", FileAttribute.Normal); StringType.StrCmp(str, "", false) != 0; str = FileSystem.Dir())
                {
                    File.Delete(modGlobal.DesignerCacheFolder + str);
                }
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                ProjectData.ClearProjectError();
            }
            modGlobal.Engines.Remove(this.Name);
        }

        public bool FieldExistsInRow(CRow oRow, string strField)
        {
            bool flag = false;
            try
            {
                CField field = (CField) oRow.Fields[strField];
                flag = true;
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                flag = false;
                ProjectData.ClearProjectError();
            }
            return flag;
        }

        public string FullURL(string strRelativeURL)
        {
            if (strRelativeURL == null)
            {
                strRelativeURL = "";
            }
            if (strRelativeURL.IndexOf("://") == -1)
            {
                string homePage = this.HomePage;
                if (homePage.EndsWith("/"))
                {
                    homePage = homePage.Substring(0, homePage.Length - 1);
                }
                if (strRelativeURL.StartsWith("/"))
                {
                    strRelativeURL = strRelativeURL.Substring(1);
                }
                if (strRelativeURL.StartsWith(":"))
                {
                    strRelativeURL = homePage + strRelativeURL;
                }
                else
                {
                    strRelativeURL = homePage + "/" + strRelativeURL;
                }
            }
            return strRelativeURL;
        }

        public Hashtable GetCachedPages()
        {
            Hashtable hashtable = new Hashtable();
            for (string str = FileSystem.Dir(modGlobal.DesignerCacheFolder + modGlobal.g_oStrings.FixFilename(this.Name) + "*.csh", FileAttribute.Normal); StringType.StrCmp(str, "", false) != 0; str = FileSystem.Dir())
            {
                string key = str.Substring(modGlobal.g_oStrings.FixFilename(this.Name).Length + 1, (str.Length - modGlobal.g_oStrings.FixFilename(this.Name).Length) - 5);
                hashtable.Add(key, str);
            }
            return hashtable;
        }

        public DataTable GetFieldValues(DataTable tblInput, CField oField)
        {
            DataTable table2 = new DataTable();
            string str4 = "";
            CParseHTML ehtml = new CParseHTML();
            DataColumn column = new DataColumn();
            column.DataType = Type.GetType("System.String");
            column.ColumnName = "input";
            table2.Columns.Add(column);
            column = new DataColumn();
            column.DataType = Type.GetType("System.String");
            column.ColumnName = "output";
            table2.Columns.Add(column);
            CRow row = oField.Row;
            for (int i = 0; i < tblInput.Rows.Count; i++)
            {
                string str2;
                string str3;
                DataRow row2 = tblInput.Rows[i];
                if (Information.IsDBNull(RuntimeHelpers.GetObjectValue(row2[oField.Column - 1])))
                {
                    str2 = "";
                }
                else
                {
                    str2 = row2[oField.Column - 1].ToString();
                }
                try
                {
                    str3 = oField.Transform(row2, 0).Trim();
                }
                catch (Exception exception1)
                {
                    ProjectData.SetProjectError(exception1);
                    str3 = "";
                    ProjectData.ClearProjectError();
                }
                DataRow row3 = table2.NewRow();
                row3["input"] = str2;
                if (oField.InheritIfBlank && (StringType.StrCmp(str3, "", false) == 0))
                {
                    str3 = str4;
                }
                row3["output"] = str3;
                table2.Rows.Add(row3);
                str4 = str3;
            }
            return table2;
        }

        public int GetNumberOfPages(string strHTML)
        {
            int length = 1;
            try
            {
                switch (this.PageType)
                {
                    case EPageType.ptSingle:
                        length = 1;
                        goto Label_008C;

                    case EPageType.ptPageNumber:
                        strHTML = this.PagesTransforms.Transform(strHTML);
                        if (StringType.StrCmp(strHTML, "", false) == 0)
                        {
                            break;
                        }
                        length = IntegerType.FromString(strHTML);
                        if (this.ZeroBasedPages)
                        {
                            length++;
                        }
                        goto Label_008C;

                    case EPageType.ptNextPageURL:
                        length = -1;
                        goto Label_008C;

                    case EPageType.ptStatic:
                        length = this.NextPage.Split(new char[] { ';' }).GetLength(0);
                        goto Label_008C;

                    default:
                        goto Label_008C;
                }
                length = 1;
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                length = 1;
                ProjectData.ClearProjectError();
            }
        Label_008C:
            if (length == 0)
            {
                length = 1;
            }
            return length;
        }

        public DataTable GetTable(CParseHTML oParseHTML)
        {
            DataTable nextTable;
            int skip = this.TableFind.Skip;
            if (this.DataType == EDataType.dtDelimited)
            {
                if (StringType.StrCmp(this.LineBreak, "", false) == 0)
                {
                    throw new Exception("Error parsing web page: no line break");
                }
                try
                {
                    nextTable = oParseHTML.CreateTable(this.Delimiter, this.Bounder, this.LineBreak, this.DataFind, "--Row--");
                }
                catch (Exception exception1)
                {
                    ProjectData.SetProjectError(exception1);
                    throw new Exception("Error parsing web page: table processing");
                }
            }
            else
            {
                oParseHTML.PositionAtStart();
                while (skip >= 0)
                {
                    if (!oParseHTML.PositionAtNext(this.TableFind.Table, true))
                    {
                        throw new Exception("Error parsing web page: table seek");
                    }
                    if (skip != 0)
                    {
                        oParseHTML.Position++;
                    }
                    skip--;
                }
                try
                {
                    nextTable = oParseHTML.GetNextTable("--Row--", this.IncludeRowTag);
                }
                catch (Exception exception2)
                {
                    ProjectData.SetProjectError(exception2);
                    Exception exception = exception2;
                    throw new Exception("Error parsing web page: table processing\r\n" + exception.Message);
                }
            }
            int num = 0;
            foreach (DataRow row in nextTable.Rows)
            {
                if (num < this.SkipHeader)
                {
                    row[0] = "SKIPPED";
                }
                else
                {
                    row[0] = this.MatchingRow(row).Name;
                }
                num++;
            }
            return nextTable;
        }

        public void Init()
        {
            this.Status = EEngineStatus.esOK;
            this.Files = null;
            this.Pages = null;
            this.DiscardedCount = 0;
        }

        public void Load()
        {
            bool flag = false;
            this.DefaultRow = null;
            this.Menus = new Collection();
            this.AllFields = new Collection();
            this.Rows = new Collection();
            CXMLNode node = new CXMLNode(this.Filename);
            node = node.SelectNode("engine");
            this.Version = node["version", ""];

            if (StringType.StrCmp(this.Version, "0.7b", false) == 0)
            {
                this.Category = node["category", ""];
                this.PageType = EPageType.ptSingle;
                this.Login = null;
                foreach (CXMLNode node2 in node.ChildNodes)
                {
                    string name = node2.Name;
                    if (StringType.StrCmp(name, "general", false) == 0)
                    {
                        this.HomePage = node2["homepage", ""];
                        this.EngineDate = modGlobal.ConvDateWithMask(node2["date", ""], "yyyyMMdd", new DateTime(0x8aab5b7044c8000L));
                        string str2 = node2["tooltip", "|"];
                        this.ToolTip = Strings.Replace(str2.Substring(1), StringType.FromChar(str2[0]), "\r\n", 1, -1, CompareMethod.Binary);
                        continue;
                    }
                    if (StringType.StrCmp(name, "data", false) == 0)
                    {
                        string sLeft = node2["type", ""];
                        if (StringType.StrCmp(sLeft, "table", false) == 0)
                        {
                            this.DataType = EDataType.dtTable;
                            this.TableFind.Table = node2["tablefind", ""];
                            this.TableFind.Skip = node2["tableskip", 0];
                            this.IncludeRowTag = node2["includerowtag", false];
                        }
                        else if (StringType.StrCmp(sLeft, "delimited", false) == 0)
                        {
                            this.DataType = EDataType.dtDelimited;
                            this.Delimiter = node2["delimiter", ""];
                            this.Bounder = node2["bounder", ""];
                            this.LineBreak = node2["linebreak", ""];
                            this.DataFind = new CTextTransforms(node2.SelectNode("datafind"));
                        }
                        this.SkipHeader = node2["skipheader", 0];
                        continue;
                    }
                    if (StringType.StrCmp(name, "login", false) == 0)
                    {
                        this.Login = new CLogin(node2);
                        continue;
                    }
                    if (StringType.StrCmp(name, "pages", false) == 0)
                    {
                        string str3 = node2["type", ""];
                        if (StringType.StrCmp(str3, "singlepage", false) == 0)
                        {
                            this.PageType = EPageType.ptSingle;
                        }
                        else if (StringType.StrCmp(str3, "pagenumber", false) == 0)
                        {
                            this.PageType = EPageType.ptPageNumber;
                        }
                        else if (StringType.StrCmp(str3, "nextpageurl", false) == 0)
                        {
                            this.PageType = EPageType.ptNextPageURL;
                        }
                        else if (StringType.StrCmp(str3, "static", false) == 0)
                        {
                            this.PageType = EPageType.ptStatic;
                        }
                        else
                        {
                            this.PageType = EPageType.ptSingle;
                        }
                        this.SearchPage = node2["searchpage", ""];
                        this.NextPage = node2["nextpage", ""];
                        this.SearchDelimiter = node2["searchdelimiter", ""];
                        if (StringType.StrCmp(this.SearchDelimiter, "", false) == 0)
                        {
                            this.SearchDelimiter = "+";
                        }
                        this.ZeroBasedPages = node2["zerobased", false];
                        this.PagesTransforms = new CTextTransforms(node2.SelectNode("pageident"));
                        continue;
                    }
                    if (StringType.StrCmp(name, "action", false) == 0)
                    {
                        CMenu item = new CMenu(node2);
                        this.Menus.Add(item, item.Key, null, null);
                    }
                    else if (StringType.StrCmp(name, "row", false) == 0)
                    {
                        CRow row = new CRow(node2);
                        this.Rows.Add(row, row.Key, null, null);
                        if (row.IsFinal)
                        {
                            flag = true;
                        }
                    }
                }
                foreach (CRow row in this.Rows)
                {
                    IEnumerator enumerator = null;
                    if (row.IsDefault)
                    {
                        this.DefaultRow = row;
                    }
                    try
                    {
                        enumerator = row.Fields.GetEnumerator();
                        while (enumerator.MoveNext())
                        {
                            CField current = (CField) enumerator.Current;
                            this.AllFields.Add(current, current.GlobalKey, null, null);
                        }
                        continue;
                    }
                    finally
                    {
                        if (enumerator is IDisposable)
                        {
                            ((IDisposable) enumerator).Dispose();
                        }
                    }
                }
                if (this.DefaultRow == null)
                {
                    this.DefaultRow = new CRow();
                    this.DefaultRow.IsDefault = true;
                    if (this.Rows.Count == 0)
                    {
                        this.Rows.Add(this.DefaultRow, this.DefaultRow.Key, null, null);
                    }
                    else
                    {
                        this.Rows.Add(this.DefaultRow, this.DefaultRow.Key, 1, null);
                    }
                }
                if (!flag)
                {
                    this.DefaultRow.IsFinal = true;
                }
            }
        }

        public CRow MatchingRow(DataRow r)
        {
            CRow row2 = new CRow();
            foreach (CRow row3 in this.Rows)
            {
                if (row3.IsDefault)
                {
                    row2 = row3;
                }
                else if (row3.Matches(r))
                {
                    row2 = row3;
                }
            }
            return row2;
        }

        private void ProcessPage(DataTable tbl, CPage oPage)
        {
            int skipHeader = oPage.Engine.SkipHeader;
            CFile oFile = new CFile();
            CFile file2 = null;
            while (skipHeader < tbl.Rows.Count)
            {
                DataRow row2 = tbl.Rows[skipHeader];
                CRow row = (CRow) oPage.Engine.Rows[RuntimeHelpers.GetObjectValue(row2[0])];
                foreach (CField field in row.Fields)
                {
                    try
                    {
                        oFile[field.Name] = field.Transform(row2, 1);
                        continue;
                    }
                    catch (Exception exception1)
                    {
                        ProjectData.SetProjectError(exception1);
                        oFile[field.Name] = "";
                        ProjectData.ClearProjectError();
                        continue;
                    }
                }
                if (row.IsFinal)
                {
                    if (file2 != null)
                    {
                        foreach (CField field in oPage.Engine.AllFields)
                        {
                            if (field.InheritIfBlank && (StringType.StrCmp(oFile[field.Name], "", false) == 0))
                            {
                                oFile[field.Name] = file2[field.Name];
                            }
                        }
                    }
                    oPage.AddFile(oFile);
                    if (this.FileStatusChanged != null)
                    {
                        this.FileStatusChanged(oFile);
                    }
                    if ((modGlobal.g_oSettings.MaxResultsPerEngine != 0) && (this.Files.Count == modGlobal.g_oSettings.MaxResultsPerEngine))
                    {
                        break;
                    }
                    file2 = oFile;
                    oFile = new CFile();
                }
                skipHeader++;
            }
        }

        public string RelativeURL(string strFullURL)
        {
            if (strFullURL == null)
            {
                strFullURL = "";
            }
            strFullURL = strFullURL.Trim();
            if (strFullURL.ToLower().StartsWith(this.HomePage.ToLower()))
            {
                strFullURL = strFullURL.Substring(this.HomePage.Length);
            }
            if (strFullURL.StartsWith("/"))
            {
                strFullURL = strFullURL.Substring(1);
            }
            return strFullURL;
        }

        public void RemoveField(CField oField)
        {
            this.AllFields.Remove(oField.GlobalKey);
            oField.Row.Fields.Remove(oField.RowKey);
        }

        public void RemoveRow(CRow oRow)
        {
            bool flag = false;
            foreach (CField field in oRow.Fields)
            {
                this.AllFields.Remove(field.GlobalKey);
            }
            this.Rows.Remove(oRow.Key);
            IEnumerator enumerator = this.Rows.GetEnumerator();

            while (enumerator.MoveNext())
            {
                oRow = (CRow) enumerator.Current;
                if (oRow.IsFinal)
                {
                    flag = true;
                }
            }
            
            if (!flag)
            {
                this.DefaultRow.IsFinal = true;
            }
        }

        public void Save()
        {
            try
            {
                CXMLNode oXMLNode = new CXMLNode().Create("engine");
                oXMLNode.AddAttribute("version", this.Version, false);
                oXMLNode.AddAttribute("category", this.Category, false);
                CXMLNode node4 = oXMLNode.Create("general");
                node4.CreateText("homepage", this.HomePage, false);
                node4.CreateText("date", Strings.Format(this.EngineDate, "yyyyMMdd"), false);
                node4.CreateText("tooltip", "|" + Strings.Replace(this.ToolTip, "\r\n", "|", 1, -1, CompareMethod.Binary), false);
                node4 = null;
                CXMLNode node3 = oXMLNode.Create("data");
                node3.CreateText("skipheader", Interaction.IIf(this.SkipHeader != 0, this.SkipHeader.ToString(), "").ToString(), false);
                switch (this.DataType)
                {
                    case EDataType.dtTable:
                        node3.AddAttribute("type", "table", false);
                        node3.CreateText("tablefind", this.TableFind.Table, false);
                        node3.CreateText("tableskip", Interaction.IIf(this.TableFind.Skip != 0, this.TableFind.Skip.ToString(), "").ToString(), false);
                        node3.CreateText("includerowtag", Interaction.IIf(this.IncludeRowTag, "Y", "").ToString(), false);
                        break;

                    case EDataType.dtDelimited:
                        node3.AddAttribute("type", "delimited", false);
                        node3.CreateText("delimiter", this.Delimiter, false);
                        node3.CreateText("bounder", this.Bounder, false);
                        node3.CreateText("linebreak", this.LineBreak, false);
                        if (this.DataFind != null)
                        {
                            this.DataFind.Save(node3.Create("datafind"));
                        }
                        break;
                }
                node3 = null;
                if (this.Login != null)
                {
                    this.Login.Save(oXMLNode);
                }
                CXMLNode node2 = oXMLNode.Create("pages");
                switch (this.PageType)
                {
                    case EPageType.ptPageNumber:
                        node2.AddAttribute("type", "pagenumber", false);
                        node2.CreateText("zerobased", Interaction.IIf(this.ZeroBasedPages, "Y", "").ToString(), false);
                        break;

                    case EPageType.ptNextPageURL:
                        node2.AddAttribute("type", "nextpageurl", false);
                        break;

                    case EPageType.ptStatic:
                        node2.AddAttribute("type", "static", false);
                        break;
                }
                node2.CreateText("searchpage", this.SearchPage, false);
                node2.CreateText("nextpage", this.NextPage, false);
                node2.CreateText("searchdelimiter", Interaction.IIf(StringType.StrCmp(this.SearchDelimiter, "+", false) == 0, "", this.SearchDelimiter).ToString(), false);
                if (((this.PageType != EPageType.ptSingle) && (this.PagesTransforms != null)) && ((this.PagesTransforms.TransformsCollection != null) && (this.PagesTransforms.TransformsCollection.Count != 0)))
                {
                    this.PagesTransforms.Save(node2.Create("pageident"));
                }
                foreach (CMenu menu in this.Menus)
                {
                    menu.Save(oXMLNode);
                }
                foreach (CRow row in this.Rows)
                {
                    row.Save(oXMLNode);
                }
                oXMLNode.Save(this.Filename);
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                Interaction.MsgBox(exception1.ToString(), MsgBoxStyle.OkCancel, "Error saving");
                ProjectData.ClearProjectError();
            }
        }

        public void SaveNew(string strFilename, string strCategory)
        {
            this._strFilename = strFilename;
            this.Version = "0.7b";
            this.Category = strCategory;
            this.Login = null;
            this.PageType = EPageType.ptSingle;
            this.DefaultRow = new CRow();
            this.DefaultRow.IsDefault = true;
            this.DefaultRow.IsFinal = true;
            this.Rows.Add(this.DefaultRow, this.DefaultRow.Key, null, null);
            this.ToolTip = "Title: ~~Title~~\r\nSize: ~~Size~~\r\nCategory: ~~Category~~\r\nSeeds: ~~Seeds~~\r\nPeers: ~~Peers~~";
            this.Save();
            this.Load();
        }

        public void Search()
        {
            CPage page = new CPage();
            try
            {
                string hTML = "";
                this.Pages = null;
                this.Files = null;
                this.DiscardedCount = 0;
                int intPage = 1;
                string strURL = this[this.CurrentSearchText, intPage, hTML];
                this.Status = EEngineStatus.esRunning;
                if (this.EngineStatusChanged != null)
                {
                    this.EngineStatusChanged(this);
                }
            Label_0043:
                page = this.AddPage(strURL);
                page.Status = CPage.EPageStatus.psDownloading;
                if (this.PageStatusChanged != null)
                {
                    this.PageStatusChanged(page);
                }
                CParseHTML oParseHTML = new CParseHTML();
                try
                {
                    if (modGlobal.ONLINE)
                    {
                        if (this.Login == null)
                        {
                            oParseHTML.GetPageHTML(page.URL, "");
                        }
                        else
                        {
                            oParseHTML.GetPageHTML(page.URL, this.Login.Cookie);
                        }
                    }
                    else
                    {
                        try
                        {
                            string strFilename = modGlobal.DesignerCacheFolder + modGlobal.g_oStrings.FixFilename(this.Name + " " + this.CurrentSearchText + ".html");
                            oParseHTML.LoadFromFile(strFilename, false);
                        }
                        catch (Exception exception1)
                        {
                            ProjectData.SetProjectError(exception1);
                            string sLeft = FileSystem.Dir(modGlobal.DesignerCacheFolder + modGlobal.g_oStrings.FixFilename(this.Name) + "*.html", FileAttribute.Normal);
                            if (StringType.StrCmp(sLeft, "", false) == 0)
                            {
                                throw new Exception("No Cache File");
                            }
                            sLeft = modGlobal.DesignerCacheFolder + sLeft;
                            oParseHTML.LoadFromFile(sLeft, false);
                            ProjectData.ClearProjectError();
                        }
                    }
                    hTML = oParseHTML.HTML;
                }
                catch (ThreadAbortException exception8)
                {
                    ProjectData.SetProjectError(exception8);
                    ThreadAbortException exception = exception8;
                    throw exception;
                }
                catch (Exception exception9)
                {
                    ProjectData.SetProjectError(exception9);
                    Exception exception2 = exception9;
                    page.ErrorMessage = "Error downloading page: " + page.URL + "\r\n" + exception2.Message;
                    page.Status = CPage.EPageStatus.psError;
                    this.Status = EEngineStatus.esError;
                    if (this.PageStatusChanged != null)
                    {
                        this.PageStatusChanged(page);
                    }
                    if (this.EngineStatusChanged != null)
                    {
                        this.EngineStatusChanged(this);
                    }
                    ProjectData.ClearProjectError();
                    return;
                }
                if (StringType.StrCmp(oParseHTML.HTML, "", false) == 0)
                {
                    page.ErrorMessage = "Error downloading page: " + page.URL;
                    page.Status = CPage.EPageStatus.psError;
                    this.Status = EEngineStatus.esError;
                    if (this.PageStatusChanged != null)
                    {
                        this.PageStatusChanged(page);
                    }
                    if (this.EngineStatusChanged != null)
                    {
                        this.EngineStatusChanged(this);
                    }
                }
                else
                {
                    DataTable table;
                    page.Status = CPage.EPageStatus.psExamining;
                    if (this.PageStatusChanged != null)
                    {
                        this.PageStatusChanged(page);
                    }
                    try
                    {
                        table = this.GetTable(oParseHTML);
                    }
                    catch (ThreadAbortException exception10)
                    {
                        ProjectData.SetProjectError(exception10);
                        ThreadAbortException exception3 = exception10;
                        throw exception3;
                    }
                    catch (Exception exception11)
                    {
                        ProjectData.SetProjectError(exception11);
                        Exception exception4 = exception11;
                        page.ErrorMessage = "No data found on page: " + page.URL + "\r\n" + exception4.Message;
                        page.Status = CPage.EPageStatus.psNoResults;
                        this.Status = EEngineStatus.esError;
                        if (this.PageStatusChanged != null)
                        {
                            this.PageStatusChanged(page);
                        }
                        if (this.EngineStatusChanged != null)
                        {
                            this.EngineStatusChanged(this);
                        }
                        ProjectData.ClearProjectError();
                        return;
                    }
                    try
                    {
                        this.ProcessPage(table, page);
                    }
                    catch (ThreadAbortException exception12)
                    {
                        ProjectData.SetProjectError(exception12);
                        ThreadAbortException exception5 = exception12;
                        throw exception5;
                    }
                    catch (Exception exception13)
                    {
                        ProjectData.SetProjectError(exception13);
                        Exception exception6 = exception13;
                        page.ErrorMessage = "Error parsing data on page: " + page.URL + "\r\n" + exception6.Message;
                        page.Status = CPage.EPageStatus.psError;
                        this.Status = EEngineStatus.esError;
                        if (this.PageStatusChanged != null)
                        {
                            this.PageStatusChanged(page);
                        }
                        if (this.EngineStatusChanged != null)
                        {
                            this.EngineStatusChanged(this);
                        }
                        ProjectData.ClearProjectError();
                        return;
                    }
                    page.Status = CPage.EPageStatus.psOk;
                    if (this.PageStatusChanged != null)
                    {
                        this.PageStatusChanged(page);
                    }
                    if (((modGlobal.g_oSettings.MaxPagesPerEngine == 0) || (this.Pages.Count != modGlobal.g_oSettings.MaxPagesPerEngine)) && (((modGlobal.g_oSettings.MaxResultsPerEngine == 0) || (this.Files == null)) || (this.Files.Count != modGlobal.g_oSettings.MaxResultsPerEngine)))
                    {
                        int numberOfPages = 0;
                        if (intPage == 1)
                        {
                            numberOfPages = this.GetNumberOfPages(hTML);
                        }
                        intPage++;
                        strURL = this[this.CurrentSearchText, intPage, hTML];
                        if (!(((intPage > numberOfPages) & (numberOfPages != -1)) | (StringType.StrCmp(strURL, "", false) == 0)))
                        {
                            goto Label_0043;
                        }
                    }
                    this.Status = EEngineStatus.esOK;
                    if (this.EngineStatusChanged != null)
                    {
                        this.EngineStatusChanged(this);
                    }
                }
            }
            catch (ThreadAbortException exception14)
            {
                ProjectData.SetProjectError(exception14);
                ThreadAbortException exception7 = exception14;
                if (page != null)
                {
                    page.Status = CPage.EPageStatus.psStopped;
                    if (this.PageStatusChanged != null)
                    {
                        this.PageStatusChanged(page);
                    }
                }
                this.Status = EEngineStatus.esStopped;
                if (this.EngineStatusChanged != null)
                {
                    this.EngineStatusChanged(this);
                }
                ProjectData.ClearProjectError();
            }
        }

        public string Filename
        {
            get
            {
                return this._strFilename;
            }
            set
            {
                this._strFilename = value;
                this.Load();
            }
        }

        public EImageIndex ImageIndex
        {
            get
            {
                EImageIndex index = new EImageIndex();
                switch (this.Status)
                {
                    case EEngineStatus.esNone:
                        index = EImageIndex.iiOut;
                        break;
                    case EEngineStatus.esOK:
                        index = EImageIndex.iiGreen;
                        break;
                    case EEngineStatus.esRunning:
                        index = EImageIndex.iiYellow;
                        break;
                    case EEngineStatus.esWaiting:
                        index = EImageIndex.iiOut;
                        break;
                    case EEngineStatus.esStopped:
                        index = EImageIndex.iiGreen;
                        break;
                    case EEngineStatus.esError:
                        index = EImageIndex.iiRed;
                        break;
                }
                return index;
            }
        }

        public bool IsAvailable
        {
            get
            {
                return ((this.Login == null) || (StringType.StrCmp(this.Login.Cookie, "", false) != 0));
            }
        }

        public bool IsCurrent
        {
            get
            {
                return (this.IsCurrentNoSave & this.IsAvailable);
            }
            set
            {
                this.IsCurrentNoSave = value & this.IsAvailable;
                modGlobal.g_oSettings.SaveCurrentEngines();
            }
        }

        public string this[string strHTML]
        {
            get
            {
                if (this.Pages == null)
                {
                    return "";
                }
                return this.PagesTransforms.Transform(strHTML).Trim();
            }
        }

        public string this[string strSearchText, int intPage, string strHTML]
        {
            get
            {
                string searchPage = "";
                if (intPage == 1)
                {
                    searchPage = this.SearchPage;
                }
                else
                {
                    switch (this.PageType)
                    {
                        case EPageType.ptPageNumber:
                            searchPage = Strings.Replace(this.NextPage, "~~PG~~", Interaction.IIf(this.ZeroBasedPages, intPage - 1, intPage).ToString(), 1, -1, CompareMethod.Binary);
                            goto Label_00E5;

                        case EPageType.ptNextPageURL:
                        {
                            string sLeft = this[strHTML];
                            if (StringType.StrCmp(sLeft, "", false) != 0)
                            {
                                searchPage = Strings.Replace(this.NextPage, "~~PG~~", sLeft, 1, -1, CompareMethod.Binary);
                            }
                            else
                            {
                                searchPage = "";
                            }
                            goto Label_00E5;
                        }
                        case EPageType.ptStatic:
                        {
                            string[] strArray = this.NextPage.Split(new char[] { ';' });
                            int length = strArray.GetLength(0);
                            if (intPage <= length)
                            {
                                searchPage = Strings.Replace(strArray[0], "~~PG~~", strArray[intPage - 1], 1, -1, CompareMethod.Binary);
                            }
                            else
                            {
                                searchPage = "";
                            }
                            goto Label_00E5;
                        }
                    }
                }
            Label_00E5:
                searchPage = Strings.Replace(searchPage, "~~ST~~", Strings.Replace(strSearchText, " ", this.SearchDelimiter, 1, -1, CompareMethod.Binary), 1, -1, CompareMethod.Binary);
                if (StringType.StrCmp(searchPage, "", false) != 0)
                {
                    searchPage = this.FullURL(searchPage);
                }
                return searchPage;
            }
        }

        public string StatusString
        {
            get
            {
                string str = "";
                switch (this.Status)
                {
                    case EEngineStatus.esNone:
                        str = "None";
                        break;
                    case EEngineStatus.esOK:
                        str = "OK";
                        break;
                    case EEngineStatus.esRunning:
                        str = "Running";
                        break;
                    case EEngineStatus.esWaiting:
                        str = "Waiting";
                        break;
                    case EEngineStatus.esStopped:
                        str = "Stopped";
                        break;
                    case EEngineStatus.esError:
                        str = "Error";
                        break;
                }
                return str;
            }
        }

        public enum EDataType
        {
            dtTable,
            dtDelimited
        }

        public enum EEngineStatus
        {
            esNone,
            esOK,
            esRunning,
            esWaiting,
            esStopped,
            esError
        }

        public enum EImageIndex
        {
            iiBlank,
            iiOut,
            iiRed,
            iiYellow,
            iiGreen
        }

        public delegate void EngineStatusChangedEventHandler(CEngine oEngine);

        public enum EPageType
        {
            ptSingle,
            ptPageNumber,
            ptNextPageURL,
            ptStatic
        }

        public delegate void FileStatusChangedEventHandler(CFile oFile);

        public delegate void PageStatusChangedEventHandler(CPage oPage);

        [StructLayout(LayoutKind.Sequential)]
        public struct StructTableFind
        {
            public string Table;
            public int Skip;
        }
    }
}

