﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using Microsoft.VisualBasic.CompilerServices;
    using System;

    public class CFilter
    {
        public bool bAllowBlank = false;
        public DateTime DateValue;
        private double dblFilesizeInKB;
        public string FieldName;
        public CField.EFieldType FieldType;
        private string m_strFilesizeValue;
        private string m_strTextValue;
        public double NumberValue;
        public EOperator Operator = EOperator.opEqualTo;

        private bool CompareDates(string strText)
        {
            bool flag;
            DateTime time = modGlobal.ConvDate(strText, new DateTime(0x8aab5b7044c8000L));
            switch (this.Operator)
            {
                case EOperator.opEqualTo:
                    return (DateTime.Compare(time, this.DateValue) == 0);

                case EOperator.opLessThan:
                    return (DateTime.Compare(time, this.DateValue) < 0);

                case EOperator.opLessThanOrEqualTo:
                    return (DateTime.Compare(time, this.DateValue) <= 0);

                case EOperator.opGreaterThan:
                    return (DateTime.Compare(time, this.DateValue) > 0);

                case EOperator.opGreaterThanOrEqualTo:
                    return (DateTime.Compare(time, this.DateValue) >= 0);

                case EOperator.opNotEqualTo:
                    return (DateTime.Compare(time, this.DateValue) != 0);
            }
            return flag;
        }

        private bool CompareNumbers(string strText)
        {
            bool flag;
            double num = Conversion.Val(strText);
            switch (this.Operator)
            {
                case EOperator.opEqualTo:
                    return (num == this.NumberValue);

                case EOperator.opLessThan:
                    return (num < this.NumberValue);

                case EOperator.opLessThanOrEqualTo:
                    return (num <= this.NumberValue);

                case EOperator.opGreaterThan:
                    return (num > this.NumberValue);

                case EOperator.opGreaterThanOrEqualTo:
                    return (num >= this.NumberValue);

                case EOperator.opNotEqualTo:
                    return (num != this.NumberValue);
            }
            return flag;
        }

        private bool CompareSizes(string strText)
        {
            bool flag;
            double num = modGlobal.FilesizeInKB(strText);
            switch (this.Operator)
            {
                case EOperator.opEqualTo:
                    return (num == this.dblFilesizeInKB);

                case EOperator.opLessThan:
                    return (num < this.dblFilesizeInKB);

                case EOperator.opLessThanOrEqualTo:
                    return (num <= this.dblFilesizeInKB);

                case EOperator.opGreaterThan:
                    return (num > this.dblFilesizeInKB);

                case EOperator.opGreaterThanOrEqualTo:
                    return (num >= this.dblFilesizeInKB);

                case EOperator.opNotEqualTo:
                    return (num != this.dblFilesizeInKB);
            }
            return flag;
        }

        private bool CompareText(string strText)
        {
            strText = strText.ToLower();
            foreach (string str in Strings.Split(this.TextValue, " ", -1, CompareMethod.Binary))
            {
                if ((StringType.StrCmp(str, "", false) != 0) && (strText.IndexOf(str) == -1))
                {
                    return false;
                }
            }
            return true;
        }

        public bool Matches(string strText)
        {
            bool flag;
            if (StringType.StrCmp(strText, "", false) == 0)
            {
                return this.bAllowBlank;
            }
            switch (this.FieldType)
            {
                case CField.EFieldType.ftText:
                    return this.CompareText(strText);

                case CField.EFieldType.ftNumber:
                    return this.CompareNumbers(strText);

                case CField.EFieldType.ftFilesize:
                    return this.CompareSizes(strText);

                case CField.EFieldType.ftDate:
                    return this.CompareDates(strText);
            }
            return flag;
        }

        public string ColumnKey
        {
            get
            {
                return (this.FieldName + ((int) this.FieldType).ToString());
            }
        }

        public string FilesizeValue
        {
            get
            {
                return this.m_strFilesizeValue;
            }
            set
            {
                this.m_strFilesizeValue = value;
                this.dblFilesizeInKB = modGlobal.FilesizeInKB(value);
            }
        }

        public string OperatorString
        {
            get
            {
                string str;
                switch (this.Operator)
                {
                    case EOperator.opEqualTo:
                        return "=";

                    case EOperator.opLessThan:
                        return "<";

                    case EOperator.opLessThanOrEqualTo:
                        return "<=";

                    case EOperator.opGreaterThan:
                        return ">";

                    case EOperator.opGreaterThanOrEqualTo:
                        return ">=";

                    case EOperator.opNotEqualTo:
                        return "<>";
                }
                return str;
            }
            set
            {
                string sLeft = value;
                if (StringType.StrCmp(sLeft, "=", false) == 0)
                {
                    this.Operator = EOperator.opEqualTo;
                }
                else if (StringType.StrCmp(sLeft, "<", false) == 0)
                {
                    this.Operator = EOperator.opLessThan;
                }
                else if (StringType.StrCmp(sLeft, "<=", false) == 0)
                {
                    this.Operator = EOperator.opLessThanOrEqualTo;
                }
                else if (StringType.StrCmp(sLeft, ">", false) == 0)
                {
                    this.Operator = EOperator.opGreaterThan;
                }
                else if (StringType.StrCmp(sLeft, ">=", false) == 0)
                {
                    this.Operator = EOperator.opGreaterThanOrEqualTo;
                }
                else if (StringType.StrCmp(sLeft, "<>", false) == 0)
                {
                    this.Operator = EOperator.opNotEqualTo;
                }
                else
                {
                    this.Operator = EOperator.opNone;
                }
            }
        }

        public string TextValue
        {
            get
            {
                return this.m_strTextValue;
            }
            set
            {
                this.m_strTextValue = value.ToLower();
            }
        }

        public enum EOperator
        {
            opNone,
            opEqualTo,
            opLessThan,
            opLessThanOrEqualTo,
            opGreaterThan,
            opGreaterThanOrEqualTo,
            opNotEqualTo
        }
    }
}

