﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using Microsoft.VisualBasic.CompilerServices;
    using System;

    public class CFormElement
    {
        public string IdentifiedAs;
        public string Name;
        public string Other;
        public bool SelectedSubmit;
        public CParseHTML.ETag TagType;
        public string TagTypeName;
        public string Text;
        public string TypeText;
        public bool Use;
        public string Value;

        public CFormElement(string strData, CParseHTML.ETag id)
        {
            this.Text = strData;
            this.TagType = id;
            switch (id)
            {
                case CParseHTML.ETag.tagForm:
                    this.TagTypeName = "Form";
                    this.TypeText = this.GetVariable("method", strData).ToLower();
                    this.Name = this.GetVariable("name", strData);
                    this.Value = this.GetVariable("action", strData);
                    this.Use = false;
                    break;

                case CParseHTML.ETag.tagInput:
                {
                    this.TagTypeName = "Input";
                    this.TypeText = this.GetVariable("type", strData).ToLower();
                    this.Name = this.GetVariable("name", strData);
                    if (StringType.StrCmp(this.TypeText, "", false) == 0)
                    {
                        this.TypeText = "textbox";
                    }
                    this.Value = this.GetVariable("value", strData);
                    string typeText = this.TypeText;
                    if (StringType.StrCmp(typeText, "radio", false) != 0)
                    {
                        if (StringType.StrCmp(typeText, "submit", false) == 0)
                        {
                            this.Other = this.GetVariable("onclick", strData);
                            this.Use = true;
                        }
                        else if (StringType.StrCmp(typeText, "text", false) == 0)
                        {
                            this.TypeText = "textbox";
                            this.Use = true;
                        }
                        else if (StringType.StrCmp(typeText, "checkbox", false) == 0)
                        {
                            if (((StringType.StrCmp(this.GetVariable("checked", strData).ToLower(), "checked", false) == 0) | strData.ToLower().EndsWith("checked>")) | strData.ToLower().EndsWith("checked/>"))
                            {
                                this.Other = "checked";
                                this.Use = true;
                            }
                            else
                            {
                                this.Other = "unchecked";
                                this.Use = false;
                            }
                        }
                        else if (StringType.StrCmp(typeText, "button", false) == 0)
                        {
                            this.Use = false;
                        }
                        else
                        {
                            this.Use = true;
                        }
                        break;
                    }
                    if (((StringType.StrCmp(this.GetVariable("checked", strData).ToLower(), "checked", false) == 0) | strData.ToLower().EndsWith("checked>")) | strData.ToLower().EndsWith("checked/>"))
                    {
                        this.Other = "checked";
                        this.Use = true;
                    }
                    else
                    {
                        this.Other = "unchecked";
                        this.Use = false;
                    }
                    break;
                }
                case CParseHTML.ETag.tagSelect:
                    this.TagTypeName = "Select";
                    this.TypeText = "combobox";
                    this.Name = this.GetVariable("name", strData);
                    this.Use = true;
                    break;
            }
            if (StringType.StrCmp(this.Name, "", false) == 0)
            {
                this.Use = false;
            }
            this.IdentifiedAs = "";
        }

        public void AddOption(string strData)
        {
            if (((StringType.StrCmp(this.GetVariable("selected", strData).ToLower(), "selected", false) == 0) | (this.Value == null)) | strData.ToLower().EndsWith("selected>"))
            {
                this.Value = this.GetVariable("value", strData);
            }
        }

        private string GetText(string strData, int intPos)
        {
            int index;
            switch (strData[intPos])
            {
                case '"':
                    intPos++;
                    index = strData.IndexOf("\"", intPos);
                    break;

                case '\'':
                    intPos++;
                    index = strData.IndexOf("'", intPos);
                    break;

                default:
                    index = modGlobal.g_oStrings.FindNext(strData, " \r\n\t/>", intPos + 1);
                    break;
            }
            if (index != -1)
            {
                return strData.Substring(intPos, index - intPos);
            }
            return "";
        }

        private string GetVariable(string strName, string strData)
        {
            int index = strData.ToLower().IndexOf(strName + "=");
            if (index != -1)
            {
                return this.GetText(strData, (index + Strings.Len(strName)) + 1);
            }
            return "";
        }

        public EFormElementType TypeEnum
        {
            get
            {
                string typeText = this.TypeText;
                if (StringType.StrCmp(typeText, "textbox", false) == 0)
                {
                    return EFormElementType.fetTextbox;
                }
                if (StringType.StrCmp(typeText, "password", false) == 0)
                {
                    return EFormElementType.fetPassword;
                }
                if (StringType.StrCmp(typeText, "checkbox", false) == 0)
                {
                    return EFormElementType.fetCheckbox;
                }
                if (StringType.StrCmp(typeText, "button", false) == 0)
                {
                    return EFormElementType.fetButton;
                }
                if (StringType.StrCmp(typeText, "submit", false) == 0)
                {
                    return EFormElementType.fetSubmitButton;
                }
                if (StringType.StrCmp(typeText, "combobox", false) == 0)
                {
                    return EFormElementType.fetCombobox;
                }
                if (StringType.StrCmp(typeText, "hidden", false) == 0)
                {
                    return EFormElementType.fetHidden;
                }
                if (StringType.StrCmp(typeText, "radio", false) == 0)
                {
                    return EFormElementType.fetRadioButton;
                }
                return EFormElementType.fetUnknown;
            }
        }

        public enum EFormElementType
        {
            fetUnknown,
            fetTextbox,
            fetCheckbox,
            fetCombobox,
            fetPassword,
            fetButton,
            fetSubmitButton,
            fetHidden,
            fetRadioButton
        }
    }
}

