﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using System;
    using System.Collections;

    public class CMenu
    {
        public Collection Commands;
        private const string Key_Action = "action";
        private const string Key_Action_Name = "name";
        public string Name;

        public CMenu()
        {
            this.Commands = new Collection();
        }

        public CMenu(CXMLNode oXMLNode)
        {
            this.Commands = new Collection();
            this.Load(oXMLNode);
        }

        public void Load(CXMLNode oXMLNode)
        {
            IEnumerator enumerator;
            this.Name = oXMLNode.get_StringAttribute("name", "");
            try
            {
                enumerator = oXMLNode.ChildNodes.GetEnumerator();
                while (enumerator.MoveNext())
                {
                    oXMLNode = (CXMLNode) enumerator.Current;
                    CCommand item = new CCommand(oXMLNode);
                    this.Commands.Add(item, null, null, null);
                }
            }
            finally
            {
                if (enumerator is IDisposable)
                {
                    ((IDisposable) enumerator).Dispose();
                }
            }
        }

        public void Perform(CFile oFile)
        {
            foreach (CCommand command in this.Commands)
            {
                if (!command.Perform(oFile))
                {
                    break;
                }
            }
        }

        public void Save(CXMLNode oXMLNode)
        {
            IEnumerator enumerator;
            oXMLNode = oXMLNode.Create("action");
            oXMLNode.AddAttribute("name", this.Name, false);
            try
            {
                enumerator = this.Commands.GetEnumerator();
                while (enumerator.MoveNext())
                {
                    CCommand current = (CCommand) enumerator.Current;
                    CXMLNode node = oXMLNode.Create(current.Name);
                    int num2 = current.NumVariables - 1;
                    for (int i = 0; i <= num2; i++)
                    {
                        node.AddAttribute(current.get_VariableName(i), current.get_Variable(i), false);
                    }
                    node = null;
                }
            }
            finally
            {
                if (enumerator is IDisposable)
                {
                    ((IDisposable) enumerator).Dispose();
                }
            }
        }

        public override string ToString()
        {
            return this.Name;
        }

        public string Key
        {
            get
            {
                return this.Name;
            }
        }
    }
}

