﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using Microsoft.VisualBasic.CompilerServices;
    using System;
    using System.Data;
    using System.Runtime.CompilerServices;

    public class CPage
    {
        public int DiscardedCount;
        public CEngine Engine;
        public string ErrorMessage;
        public Collection Files;
        public int Index;
        public EPageStatus Status;
        public string URL;

        public void AddFile(CFile oFile)
        {
            if (this.Files == null)
            {
                this.Files = new Collection();
            }
            oFile.Page = this;
            oFile.Index = this.Files.Count + 1;
            this.Files.Add(oFile, oFile.Key, null, null);
            if (this.Engine.Files == null)
            {
                this.Engine.Files = new Collection();
            }
            this.Engine.Files.Add(oFile, null, null, null);
        }

        public DataTable GetTableByRow(DataTable tblInput, CRow oRow)
        {
            DataTable table2 = new DataTable();
            foreach (DataColumn column in tblInput.Columns)
            {
                if (StringType.StrCmp(column.Caption, "--Row--", false) != 0)
                {
                    DataColumn column2 = new DataColumn();
                    column2.DataType = Type.GetType("System.String");
                    column2.ColumnName = column.ColumnName;
                    column2.Caption = column.Caption;
                    column2.DefaultValue = "";
                    table2.Columns.Add(column2);
                }
            }
            foreach (DataRow row in tblInput.Rows)
            {
                if ((StringType.StrCmp(row[0].ToString(), "SKIPPED", false) != 0) && (((CRow) this.Engine.Rows[RuntimeHelpers.GetObjectValue(row[0])]) == oRow))
                {
                    DataRow row2 = table2.NewRow();
                    foreach (DataColumn column in tblInput.Columns)
                    {
                        if (StringType.StrCmp(column.Caption, "--Row--", false) != 0)
                        {
                            row2[column.ColumnName] = RuntimeHelpers.GetObjectValue(row[column.ColumnName]);
                        }
                    }
                    table2.Rows.Add(row2);
                }
            }
            return table2;
        }

        public DataTable TransformTable(DataTable tbl)
        {
            DataRow row2;
            this.Files = new Collection();
            int skipHeader = this.Engine.SkipHeader;
            CFile oFile = new CFile();
            CFile file2 = null;
            while (skipHeader < tbl.Rows.Count)
            {
                row2 = tbl.Rows[skipHeader];
                CRow row = (CRow) this.Engine.Rows[RuntimeHelpers.GetObjectValue(row2[0])];
                foreach (CField field in row.Fields)
                {
                    try
                    {
                        oFile.set_FieldText(field.Name, field.Transform(row2, 1));
                        continue;
                    }
                    catch (Exception exception1)
                    {
                        ProjectData.SetProjectError(exception1);
                        oFile.set_FieldText(field.Name, "");
                        ProjectData.ClearProjectError();
                        continue;
                    }
                }
                if (row.IsFinal)
                {
                    if (file2 != null)
                    {
                        foreach (CField field in this.Engine.AllFields)
                        {
                            if (field.InheritIfBlank && (StringType.StrCmp(oFile.get_FieldText(field.Name), "", false) == 0))
                            {
                                oFile.set_FieldText(field.Name, file2.get_FieldText(field.Name));
                            }
                        }
                    }
                    this.AddFile(oFile);
                    file2 = oFile;
                    oFile = new CFile();
                }
                skipHeader++;
            }
            DataTable table = new DataTable();
            foreach (CField field in this.Engine.AllFields)
            {
                DataColumn column = new DataColumn();
                column.DataType = Type.GetType("System.String");
                column.ColumnName = field.Name;
                column.Caption = field.Name;
                table.Columns.Add(column);
            }
            foreach (CFile file in this.Files)
            {
                row2 = table.NewRow();
                foreach (CField field in this.Engine.AllFields)
                {
                    row2[field.Name] = file.get_FieldText(field.Name);
                }
                table.Rows.Add(row2);
            }
            return table;
        }

        public DataTable TransformTableByRow(CRow oRow, DataTable tbl)
        {
            DataRow row;
            this.Files = new Collection();
            int num = 0;
            CFile oFile = new CFile();
            CFile file2 = null;
            while (num < tbl.Rows.Count)
            {
                row = tbl.Rows[num];
                foreach (CField field in oRow.Fields)
                {
                    try
                    {
                        oFile.set_FieldText(field.Name, field.Transform(row, 0));
                        continue;
                    }
                    catch (Exception exception1)
                    {
                        ProjectData.SetProjectError(exception1);
                        oFile.set_FieldText(field.Name, "");
                        ProjectData.ClearProjectError();
                        continue;
                    }
                }
                if (file2 != null)
                {
                    foreach (CField field in oRow.Fields)
                    {
                        if (field.InheritIfBlank && (StringType.StrCmp(oFile.get_FieldText(field.Name), "", false) == 0))
                        {
                            oFile.set_FieldText(field.Name, file2.get_FieldText(field.Name));
                        }
                    }
                }
                this.AddFile(oFile);
                file2 = oFile;
                oFile = new CFile();
                num++;
            }
            DataTable table = new DataTable();
            foreach (CField field in oRow.Fields)
            {
                DataColumn column = new DataColumn();
                column.DataType = Type.GetType("System.String");
                column.ColumnName = field.Name;
                column.Caption = field.Name;
                column.DefaultValue = "";
                table.Columns.Add(column);
            }
            foreach (CFile file in this.Files)
            {
                row = table.NewRow();
                foreach (CField field in oRow.Fields)
                {
                    row[field.Name] = file.get_FieldText(field.Name);
                }
                table.Rows.Add(row);
            }
            return table;
        }

        public string Key
        {
            get
            {
                return (this.Engine.Name + "_" + this.Index.ToString());
            }
        }

        public string StatusString
        {
            get
            {
                string str;
                switch (this.Status)
                {
                    case EPageStatus.psNone:
                        return "None";

                    case EPageStatus.psDownloading:
                        return "Downloading";

                    case EPageStatus.psError:
                        return "Error";

                    case EPageStatus.psOk:
                        return "OK";

                    case EPageStatus.psNoResults:
                        return "No Results";

                    case EPageStatus.psExamining:
                        return "Examining";

                    case EPageStatus.psStopped:
                        return "Stopped";
                }
                return str;
            }
        }

        public enum EPageStatus
        {
            psNone,
            psDownloading,
            psError,
            psOk,
            psNoResults,
            psExamining,
            psStopped
        }
    }
}

