﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using Microsoft.VisualBasic.CompilerServices;
    using System;
    using System.Data;
    using System.IO;
    using System.Net;
    using System.Runtime.CompilerServices;
    using System.Runtime.InteropServices;
    using System.Text;

    public class CParseHTML
    {
        private int _intPos = 0;
        private int _intPreviousPos;
        private string _strHTML;
        private string _strHTMLCRLFConverted;
        private string _strHTMLCRLFConvertedLower;
        private string _strHTMLLower;
        private string _strURL;

        public DataTable CreateTable(string strDelimiter, string strBounder, string strLineBreak, CTextTransforms oTextTransforms, [Optional, DefaultParameterValue("")] string strExtraColumnName)
        {
            DataColumn column;
            int num2;
            DataRow row;
            DataTable table2 = new DataTable();
            bool flag = false;
            string expression = oTextTransforms.Transform(this.HTML);
            if (StringType.StrCmp(strExtraColumnName, "", false) != 0)
            {
                column = new DataColumn();
                column.DataType = Type.GetType("System.String");
                column.ColumnName = strExtraColumnName;
                column.DefaultValue = "";
                table2.Columns.Add(column);
                num2 = 1;
            }
            else
            {
                num2 = 0;
            }
            int num = num2;
            int num3 = 0;
            string strSource = "";
            while (num3 < Strings.Len(expression))
            {
                strSource = strSource + StringType.FromChar(expression[num3]);
                if ((StringType.StrCmp(strBounder, "", false) != 0) & strSource.EndsWith(strBounder))
                {
                    flag = !flag;
                    strSource = strSource.Substring(0, strSource.Length - strBounder.Length);
                }
                else
                {
                    int num4;
                    if ((!flag & (StringType.StrCmp(strDelimiter, "", false) != 0)) && strSource.EndsWith(strDelimiter))
                    {
                        strSource = strSource.Substring(0, strSource.Length - strDelimiter.Length);
                        if (num == num2)
                        {
                            row = table2.NewRow();
                        }
                        num++;
                        if (num > table2.Columns.Count)
                        {
                            column = new DataColumn();
                            column.DataType = Type.GetType("System.String");
                            num4 = num - num2;
                            column.ColumnName = num4.ToString();
                            column.DefaultValue = "";
                            table2.Columns.Add(column);
                        }
                        row[num - 1] = modGlobal.g_oStrings.CRLFTrim(strSource);
                        strSource = "";
                    }
                    else if ((StringType.StrCmp(strLineBreak, "", false) != 0) && strSource.EndsWith(strLineBreak))
                    {
                        strSource = strSource.Substring(0, strSource.Length - strLineBreak.Length);
                        if (num == num2)
                        {
                            row = table2.NewRow();
                        }
                        num++;
                        if (num > table2.Columns.Count)
                        {
                            column = new DataColumn();
                            column.DataType = Type.GetType("System.String");
                            num4 = num - num2;
                            column.ColumnName = num4.ToString();
                            column.DefaultValue = "";
                            table2.Columns.Add(column);
                        }
                        row[num - 1] = modGlobal.g_oStrings.CRLFTrim(strSource);
                        strSource = "";
                        num = num2;
                        table2.Rows.Add(row);
                    }
                }
                num3++;
            }
            if (StringType.StrCmp(strSource, "", false) != 0)
            {
                if (num == num2)
                {
                    row = table2.NewRow();
                }
                num++;
                if (num > table2.Columns.Count)
                {
                    column = new DataColumn();
                    column.DataType = Type.GetType("System.String");
                    column.ColumnName = (num - num2).ToString();
                    column.DefaultValue = "";
                    table2.Columns.Add(column);
                }
                row[num - 1] = modGlobal.g_oStrings.CRLFTrim(strSource);
                table2.Rows.Add(row);
            }
            return table2;
        }

        public string GetNextData()
        {
            int num = 0;
            char ch2 = '?';
            if ((this._intPos + 4) < this._strHTML.Length)
            {
                bool flag2;
                do
                {
                    if (StringType.StrCmp(this._strHTML.Substring(this._intPos, 4), "<!--", false) == 0)
                    {
                        this._intPos = this._strHTML.IndexOf("-->", this._intPos) + 3;
                    }
                }
                while (flag2);
            }
            string str2 = "";
            bool flag3 = false;
            bool flag = StringType.StrCmp(StringType.FromChar(this._strHTML[this._intPos]), "<", false) == 0;
            do
            {
                char ch = this._strHTML[this._intPos];
                if (flag3)
                {
                    str2 = str2 + StringType.FromChar(ch);
                    if (StringType.StrCmp(StringType.FromChar(ch), "\"", false) == 0)
                    {
                        flag3 = false;
                    }
                }
                else if (StringType.StrCmp(StringType.FromChar(ch), "<", false) == 0)
                {
                    if (StringType.StrCmp(StringType.FromChar(this._strHTML[this._intPos + 1]), " ", false) != 0)
                    {
                        num++;
                    }
                    else
                    {
                        str2 = str2 + StringType.FromChar(ch);
                    }
                }
                else if ((StringType.StrCmp(StringType.FromChar(ch), ">", false) == 0) & (num > 0))
                {
                    num = 0;
                }
                else
                {
                    str2 = str2 + StringType.FromChar(ch);
                    if ((flag & (StringType.StrCmp(StringType.FromChar(ch), "\"", false) == 0)) && (StringType.StrCmp(StringType.FromChar(ch2), "=", false) == 0))
                    {
                        flag3 = true;
                    }
                }
                if (!char.IsWhiteSpace(ch))
                {
                    ch2 = ch;
                }
                this._intPos++;
            }
            while (!(((flag & (num == 0)) | (!flag & (num != 0))) | this.EOF));
            if (!flag & !this.EOF)
            {
                this._intPos--;
            }
            if (flag)
            {
                str2 = "<" + str2 + ">";
            }
            return str2;
        }

        public DataTable GetNextTable(string strExtraColumnName, bool bIncludeRowTag)
        {
            DataTable table2 = new DataTable();
            int num3 = 0;
            try
            {
                bool flag;
                DataColumn column;
                int num2;
                DataRow row;
                if (StringType.StrCmp(strExtraColumnName, "", false) != 0)
                {
                    column = new DataColumn();
                    column.DataType = Type.GetType("System.String");
                    column.ColumnName = strExtraColumnName;
                    column.DefaultValue = "";
                    table2.Columns.Add(column);
                    num2 = 1;
                }
                else
                {
                    num2 = 0;
                }
                this.PositionAtNext("<table", false);
                num3++;
                string nextData = this.GetNextData();
                nextData = this.GetNextData();
                ETag tagUnknown = this.TagID(nextData);
                while (num3 != 0)
                {
                    int num;
                    string str2;
                    if (tagUnknown == ETag.tagTableRow)
                    {
                        if (flag)
                        {
                            try
                            {
                                table2.Rows.Add(row);
                            }
                            catch (Exception exception1)
                            {
                                ProjectData.SetProjectError(exception1);
                                ProjectData.ClearProjectError();
                            }
                        }
                        num = num2;
                        row = table2.NewRow();
                        flag = true;
                        if (bIncludeRowTag && (Strings.Len(nextData) != 4))
                        {
                            num++;
                            str2 = nextData.Substring(4, nextData.Length - 5).Trim();
                            if (num > table2.Columns.Count)
                            {
                                column = new DataColumn();
                                column.DataType = Type.GetType("System.String");
                                int num4 = num - num2;
                                column.ColumnName = num4.ToString();
                                column.DefaultValue = "";
                                table2.Columns.Add(column);
                            }
                            row[num - 1] = modGlobal.g_oStrings.CRLFTrim(str2);
                        }
                        tagUnknown = ETag.tagUnknown;
                    }
                    else if (tagUnknown == ETag.tagTableRowEnd)
                    {
                        try
                        {
                            table2.Rows.Add(row);
                        }
                        catch (Exception exception2)
                        {
                            ProjectData.SetProjectError(exception2);
                            ProjectData.ClearProjectError();
                        }
                        flag = false;
                        tagUnknown = ETag.tagUnknown;
                    }
                    else if ((tagUnknown == ETag.tagTableCell) | (tagUnknown == ETag.tagTableHeader))
                    {
                        num++;
                        str2 = "";
                        if (this.EOF)
                        {
                            break;
                        }
                        nextData = this.GetNextData();
                        tagUnknown = this.TagID(nextData);
                        while ((((((((tagUnknown != ETag.tagTableCellEnd) & (tagUnknown != ETag.tagTableHeaderEnd)) & (tagUnknown != ETag.tagTableCell)) & (tagUnknown != ETag.tagTableHeader)) & (tagUnknown != ETag.tagTable)) & (tagUnknown != ETag.tagTableEnd)) & (tagUnknown != ETag.tagTableRow)) & (tagUnknown != ETag.tagTableRowEnd))
                        {
                            str2 = str2 + nextData;
                            if (this.EOF)
                            {
                                goto Label_031F;
                            }
                            nextData = this.GetNextData();
                            tagUnknown = this.TagID(nextData);
                        }
                        if (row == null)
                        {
                            row = table2.NewRow();
                            flag = true;
                        }
                        if (num > table2.Columns.Count)
                        {
                            column = new DataColumn();
                            column.DataType = Type.GetType("System.String");
                            column.ColumnName = (num - num2).ToString();
                            column.DefaultValue = "";
                            table2.Columns.Add(column);
                        }
                        row[num - 1] = modGlobal.g_oStrings.CRLFTrim(str2);
                    }
                    if (tagUnknown == ETag.tagTable)
                    {
                        num3++;
                    }
                    else if (tagUnknown == ETag.tagTableEnd)
                    {
                        num3--;
                    }
                    if (!((((tagUnknown == ETag.tagTableCell) | (tagUnknown == ETag.tagTableHeader)) | (tagUnknown == ETag.tagTableRow)) | (tagUnknown == ETag.tagTableRowEnd)))
                    {
                        if (this.EOF)
                        {
                            break;
                        }
                        nextData = this.GetNextData();
                        tagUnknown = this.TagID(nextData);
                    }
                }
            Label_031F:
                if (!flag)
                {
                    return table2;
                }
                try
                {
                    table2.Rows.Add(row);
                    return table2;
                }
                catch (Exception exception3)
                {
                    ProjectData.SetProjectError(exception3);
                    ProjectData.ClearProjectError();
                    return table2;
                }
            }
            catch (Exception exception4)
            {
                ProjectData.SetProjectError(exception4);
                Exception exception = exception4;
                throw exception;
                ProjectData.ClearProjectError();
            }
            return table2;
        }

        public string GetNextText()
        {
            string nextData;
            do
            {
                nextData = this.GetNextData();
            }
            while (nextData.StartsWith("<"));
            return nextData;
        }

        public void GetPageHTML(string URL, string strCookie)
        {
            string str2;
            string sLeft = "";
            if (URL.EndsWith(" POST"))
            {
                URL = URL.Substring(0, URL.Length - 5);
                int index = URL.IndexOf("?");
                if (index != -1)
                {
                    sLeft = URL.Substring(index + 1);
                    URL = URL.Substring(0, index);
                }
                str2 = "POST";
            }
            else
            {
                str2 = "GET";
            }
            ServicePointManager.Expect100Continue = false;
            if ((StringType.StrCmp(str2, "GET", false) == 0) && (StringType.StrCmp(sLeft, "", false) != 0))
            {
                URL = URL + "?" + sLeft;
            }
            HttpWebRequest request = (HttpWebRequest) WebRequest.Create(URL);
            if (StringType.StrCmp(strCookie, "", false) != 0)
            {
                request.Headers.Add("Cookie", strCookie);
            }
            if (modGlobal.g_oSettings.UseProxy)
            {
                request.Proxy = modGlobal.g_oSettings.WebProxy();
            }
            request.Timeout = modGlobal.g_oSettings.PageLoadTimeout * 0x3e8;
            request.Method = str2;
            if (StringType.StrCmp(str2, "POST", false) == 0)
            {
                request.ContentType = "application/x-www-form-urlencoded";
                StreamWriter writer = new StreamWriter(request.GetRequestStream());
                writer.Write(sLeft);
                writer.Close();
            }
            request.UserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; {E3B73135-9619-41CA-DBFD-F10504262CE5}; .NET CLR 1.1.4322; .NET CLR 2.0.50727)";
            HttpWebResponse response = (HttpWebResponse) request.GetResponse();
            Stream responseStream = response.GetResponseStream();
            Encoding encoding = Encoding.Default;
            this._strHTML = new StreamReader(responseStream, encoding).ReadToEnd();
            if (StringType.StrCmp(this._strHTML, "", false) == 0)
            {
                throw new Exception("No Data");
            }
            this._strHTML = Strings.Replace(this._strHTML, "&nbsp;", " ", 1, -1, CompareMethod.Text);
            if (response != null)
            {
                response.Close();
            }
            this._intPos = 0;
        }

        public DataTable GetStrippedTable(DataTable tblSource)
        {
            DataTable table2 = tblSource.Clone();
            foreach (DataRow row2 in tblSource.Rows)
            {
                DataRow row = table2.NewRow();
                int num2 = table2.Columns.Count - 1;
                for (int i = 0; i <= num2; i++)
                {
                    if (Information.IsDBNull(RuntimeHelpers.GetObjectValue(row2[i])))
                    {
                        row[i] = "";
                    }
                    else
                    {
                        row[i] = modGlobal.g_oStrings.StripHTMLTags(row2[i].ToString()).Trim();
                    }
                }
                table2.Rows.Add(row);
            }
            return table2;
        }

        public string GetTextBetween(string strText1, string strText2, [Optional, DefaultParameterValue(false)] bool bFromEnd)
        {
            string str;
            int num2;
            if (!bFromEnd)
            {
                num2 = this.HTML.IndexOf(strText1);
            }
            else
            {
                num2 = this.HTML.LastIndexOf(strText1);
            }
            if (num2 == -1)
            {
                return str;
            }
            num2 += strText1.Length;
            int index = this.HTML.IndexOf(strText2, num2);
            if (index == -1)
            {
                return str;
            }
            return this.HTML.Substring(num2, index - num2);
        }

        public void LoadFromFile(string strFilename, [Optional, DefaultParameterValue(false)] bool bEncrypt)
        {
            StreamReader reader = new StreamReader(strFilename);
            if (bEncrypt)
            {
                this.HTML = this.SimpleEncryptDecrypt(reader.ReadToEnd(), 0xff);
            }
            else
            {
                this.HTML = reader.ReadToEnd();
            }
            reader.Close();
        }

        public string PeekNext()
        {
            int num = this._intPos;
            string nextData = this.GetNextData();
            this._intPos = num;
            return nextData;
        }

        public bool PositionAfterNext(string strFind)
        {
            if (StringType.StrCmp(strFind, "", false) == 0)
            {
                this._intPos = 0;
                return true;
            }
            this._intPos = this._strHTML.IndexOf(strFind, this._intPos);
            if (this._intPos != -1)
            {
                this._intPos += strFind.Length;
            }
            return (this._intPos != -1);
        }

        public bool PositionAt(string strFind)
        {
            if (StringType.StrCmp(strFind, "", false) == 0)
            {
                this._intPos = 0;
                return true;
            }
            this._intPos = this._strHTML.IndexOf(strFind);
            return (this._intPos != -1);
        }

        public bool PositionAtNext(string strFind, [Optional, DefaultParameterValue(true)] bool bCaseSensitive)
        {
            if (StringType.StrCmp(strFind, "", false) == 0)
            {
                this._intPos = 0;
                return true;
            }
            if (bCaseSensitive)
            {
                this._intPos = this._strHTML.IndexOf(strFind, this._intPos);
            }
            else
            {
                this._intPos = this.HTMLLower.IndexOf(strFind.ToLower(), this._intPos);
            }
            return (this._intPos != -1);
        }

        public void PositionAtStart()
        {
            this._intPos = 0;
        }

        private void Remove(string strStart, [Optional, DefaultParameterValue("")] string strEnd)
        {
            for (int i = this._strHTML.IndexOf(strStart); i != -1; i = this._strHTML.IndexOf(strStart, i))
            {
                if (StringType.StrCmp(strEnd, "", false) == 0)
                {
                    this._strHTML = this._strHTML.Replace(strStart, "");
                }
                else
                {
                    int index = this._strHTML.IndexOf(strStart, i);
                    int num = this._strHTML.IndexOf(strEnd, index + strStart.Length);
                    this._strHTML = this._strHTML.Substring(0, index - 1) + "" + this._strHTML.Substring((num + strEnd.Length) - 1);
                }
            }
        }

        public void SaveToFile(string strFilename, [Optional, DefaultParameterValue(false)] bool bDecrypt)
        {
            StreamWriter writer = new StreamWriter(strFilename);
            if (bDecrypt)
            {
                writer.Write(this.SimpleEncryptDecrypt(this.HTML, 0xff));
            }
            else
            {
                writer.Write(this.HTML);
            }
            writer.Close();
        }

        private string SimpleEncryptDecrypt(string strText, byte bytXOR)
        {
            StringBuilder builder = new StringBuilder(strText);
            int num2 = builder.Length - 1;
            for (int i = 0; i <= num2; i++)
            {
                builder[i] = Strings.Chr(Strings.Asc(builder[i]) ^ 0xff);
            }
            return builder.ToString();
        }

        public ETag TagID(string strText)
        {
            ETag tagTableCell;
            int startIndex = 1;
            if (StringType.StrCmp(StringType.FromChar(strText[0]), "<", false) != 0)
            {
                return ETag.tagText;
            }
            bool flag = StringType.StrCmp(StringType.FromChar(strText[1]), "/", false) == 0;
            if (flag)
            {
                startIndex = 2;
            }
            else
            {
                startIndex = 1;
            }
            int num = startIndex;
            while (!char.IsWhiteSpace(strText[num]) & (StringType.StrCmp(StringType.FromChar(strText[num]), ">", false) != 0))
            {
                num++;
            }
            string sLeft = strText.Substring(startIndex, num - startIndex).ToLower();
            if (StringType.StrCmp(sLeft, "td", false) == 0)
            {
                tagTableCell = ETag.tagTableCell;
            }
            else if (StringType.StrCmp(sLeft, "tr", false) == 0)
            {
                tagTableCell = ETag.tagTableRow;
            }
            else if (StringType.StrCmp(sLeft, "th", false) == 0)
            {
                tagTableCell = ETag.tagTableHeader;
            }
            else if (StringType.StrCmp(sLeft, "table", false) == 0)
            {
                tagTableCell = ETag.tagTable;
            }
            else if (StringType.StrCmp(sLeft, "form", false) == 0)
            {
                tagTableCell = ETag.tagForm;
            }
            else if (StringType.StrCmp(sLeft, "input", false) == 0)
            {
                tagTableCell = ETag.tagInput;
            }
            else if (StringType.StrCmp(sLeft, "select", false) == 0)
            {
                tagTableCell = ETag.tagSelect;
            }
            else if (StringType.StrCmp(sLeft, "option", false) == 0)
            {
                tagTableCell = ETag.tagOption;
            }
            else
            {
                tagTableCell = ETag.tagUnknown;
            }
            if (flag)
            {
                tagTableCell += 200;
            }
            return tagTableCell;
        }

        private string TranslateCookie(string strCookie)
        {
            string sLeft = "";
            int startIndex = -1;
            int index = 0;
            do
            {
                startIndex++;
                index = strCookie.IndexOf(";", startIndex);
                if (StringType.StrCmp(sLeft, "", false) != 0)
                {
                    sLeft = sLeft + "; ";
                }
                sLeft = sLeft + strCookie.Substring(startIndex, index - startIndex);
                startIndex = index;
                startIndex = strCookie.IndexOf(",", startIndex + 1);
                startIndex = strCookie.IndexOf(",", startIndex + 1);
            }
            while (startIndex != -1);
            return sLeft;
        }

        public bool EOF
        {
            get
            {
                return (this._intPos >= this.HTML.Length);
            }
        }

        public string HTML
        {
            get
            {
                if (this._strHTML == null)
                {
                    this._strHTML = "";
                }
                return this._strHTML;
            }
            set
            {
                this._strHTML = value;
                this._strHTMLLower = null;
                this._strHTMLCRLFConverted = null;
                this._strHTMLCRLFConvertedLower = null;
                this._intPos = 0;
            }
        }

        public string HTMLCRLFConverted
        {
            get
            {
                if (this._strHTMLCRLFConverted == null)
                {
                    this._strHTMLCRLFConverted = modGlobal.g_oStrings.ConvertCRLF(this._strHTML);
                }
                return this._strHTMLCRLFConverted;
            }
        }

        public string HTMLCRLFConvertedLower
        {
            get
            {
                if (this._strHTMLCRLFConvertedLower == null)
                {
                    this._strHTMLCRLFConvertedLower = modGlobal.g_oStrings.ConvertCRLF(this.HTMLLower);
                }
                return this._strHTMLCRLFConvertedLower;
            }
        }

        public string HTMLLower
        {
            get
            {
                if (this._strHTMLLower == null)
                {
                    this._strHTMLLower = this._strHTML.ToLower();
                }
                return this._strHTMLLower;
            }
        }

        public int Position
        {
            get
            {
                return this._intPos;
            }
            set
            {
                this._intPos = value;
            }
        }

        public enum ETag
        {
            tagForm = 6,
            tagFormEnd = 0xce,
            tagInput = 7,
            tagInputEnd = 0xcf,
            tagOption = 9,
            tagOptionEnd = 0xd1,
            tagSelect = 8,
            tagSelectEnd = 0xd0,
            tagTable = 2,
            tagTableCell = 5,
            tagTableCellEnd = 0xcd,
            tagTableEnd = 0xca,
            tagTableHeader = 4,
            tagTableHeaderEnd = 0xcc,
            tagTableRow = 3,
            tagTableRowEnd = 0xcb,
            tagText = 0,
            tagUnknown = 1,
            tagUnknownEnd = 0xc9
        }
    }
}

