﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using Microsoft.VisualBasic.CompilerServices;
    using System;
    using System.Collections;
    using System.Data;
    using System.Runtime.CompilerServices;

    public class CRow
    {
        public int Column;
        public Collection Fields;
        public bool IsFinal;
        private const string Key_Field = "field";
        private const string Key_Row = "row";
        private const string Key_Row_Column = "column";
        private const string Key_Row_Final = "final";
        private const string Key_Row_Name = "name";
        private const string Key_Row_Text = "text";
        public string Name;
        public string Text;

        public CRow()
        {
            this.Fields = new Collection();
        }

        public CRow(CXMLNode oXMLNode)
        {
            this.Fields = new Collection();
            this.Load(oXMLNode);
        }

        public void Load(CXMLNode oXMLNode)
        {
            IEnumerator enumerator;
            this.Name = oXMLNode.get_StringAttribute("name", "DEFAULT");
            this.Column = oXMLNode.get_IntegerAttribute("column", 0);
            this.Text = oXMLNode.get_StringAttribute("text", "");
            this.IsFinal = oXMLNode.get_BooleanAttribute("final", false);
            try
            {
                enumerator = oXMLNode.ChildNodes.GetEnumerator();
                while (enumerator.MoveNext())
                {
                    oXMLNode = (CXMLNode) enumerator.Current;
                    if (StringType.StrCmp(oXMLNode.Name, "field", false) == 0)
                    {
                        CField item = new CField(oXMLNode, this);
                        this.Fields.Add(item, item.RowKey, null, null);
                    }
                }
            }
            finally
            {
                if (enumerator is IDisposable)
                {
                    ((IDisposable) enumerator).Dispose();
                }
            }
        }

        public bool Matches(DataRow row)
        {
            bool flag;
            if (this.Column == -1)
            {
                return true;
            }
            try
            {
                string str;
                if (Information.IsDBNull(RuntimeHelpers.GetObjectValue(row[this.Column])))
                {
                    str = "";
                }
                else
                {
                    str = row[this.Column].ToString();
                }
                if (StringType.StrCmp(this.Text, "", false) == 0)
                {
                    return (StringType.StrCmp(str.TrimStart(new char[0]), "", false) == 0);
                }
                flag = str.TrimStart(new char[0]).StartsWith(this.Text);
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                flag = false;
                ProjectData.ClearProjectError();
                return flag;
                ProjectData.ClearProjectError();
            }
            return flag;
        }

        public void Save(CXMLNode oXMLNode)
        {
            if (!((StringType.StrCmp(this.Name, "DEFAULT", false) == 0) & (this.Fields.Count == 0)))
            {
                oXMLNode = oXMLNode.Create("row");
                CXMLNode node = oXMLNode;
                if (StringType.StrCmp(this.Name, "DEFAULT", false) != 0)
                {
                    node.AddAttribute("name", this.Name, false);
                    node.AddAttribute("column", this.Column.ToString(), false);
                    node.AddAttribute("text", this.Text, false);
                }
                node.AddAttribute("final", Interaction.IIf(this.IsFinal, "Y", "").ToString(), false);
                foreach (CField field in this.Fields)
                {
                    field.Save(oXMLNode);
                }
                node = null;
            }
        }

        public override string ToString()
        {
            return this.Name;
        }

        public bool IsDefault
        {
            get
            {
                return (StringType.StrCmp(this.Name, "DEFAULT", false) == 0);
            }
            set
            {
                if (value)
                {
                    this.Name = "DEFAULT";
                }
            }
        }

        public string Key
        {
            get
            {
                return this.Name;
            }
        }
    }
}

