﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using Microsoft.VisualBasic.CompilerServices;
    using Microsoft.Win32;
    using System;
    using System.Collections;
    using System.ComponentModel;
    using System.Drawing;
    using System.Net;
    using System.Windows.Forms;

    public class CSettings
    {
        private string _AskBeforeExecute;
        private Collection _CategoryAllColumns;
        private Collection _CategoryColumns;
        private string _CurrentCategory;
        private Font _ListFont;
        private string _MatchAllTitleWords;
        private int _MaxConcurrentSearches;
        private int _MaxPagesPerEngine;
        private int _MaxResultsPerEngine;
        private int _PageLoadTimeout;
        private string _ProxyHost;
        private string _ProxyPassword;
        private int _ProxyPort;
        private string _ProxyUsername;
        private string _SelectedCookieFolder;
        private string _ShowSplashScreen;
        private string _ShowTooltips;
        private string _UserCookieFolder;
        private int _WindowHeight;
        private int _WindowState;
        private int _WindowWidth;
        private string Default_AskBeforeExecute;
        private string Default_CurrentCategory;
        private string[] Default_CurrentEngines;
        private string Default_MatchAllTitleWords;
        private int Default_MaxConcurrentSearches = 5;
        private int Default_MaxPagesPerEngine;
        private int Default_MaxResultsPerEngine;
        private int Default_PageLoadTimeout;
        private string Default_ProxyHost;
        private string Default_ProxyPassword;
        private int Default_ProxyPort;
        private string Default_ProxyUsername;
        private string Default_SelectedCookieFolder;
        private string Default_ShowSplashScreen;
        private string Default_ShowTooltips;
        private string Default_UserCookieFolder;
        private int Default_WindowHeight;
        private int Default_WindowState;
        private int Default_WindowWidth;
        private string Key_AskBeforeExecute;
        private string Key_CategoryColumns;
        private string Key_CurrentCategory;
        private string Key_CurrentEngines;
        private string Key_ListFont = "List Font";
        private string Key_MatchAllTitleWords;
        private string Key_MaxConcurrentSearches = "Max Concurrent Searches";
        private string Key_MaxPagesPerEngine;
        private string Key_MaxResultsPerEngine;
        private string Key_PageLoadTimeout;
        private string Key_ProxyHost;
        private string Key_ProxyPassword;
        private string Key_ProxyPort;
        private string Key_ProxyUsername;
        private string Key_SelectedCookieFolder;
        private string Key_ShowSplashScreen;
        private string Key_ShowTooltips;
        private string Key_UserCookieFolder;
        private string Key_WindowHeight;
        private string Key_WindowState;
        private string Key_WindowWidth;
        private int UninitialisedInteger = -2147483648;

        public CSettings()
        {
            this._MaxConcurrentSearches = this.UninitialisedInteger;
            this.Default_MaxResultsPerEngine = 5;
            this.Key_MaxResultsPerEngine = "Max Results Per Engine";
            this._MaxResultsPerEngine = this.UninitialisedInteger;
            this.Default_MaxPagesPerEngine = 0;
            this.Key_MaxPagesPerEngine = "Max Pages Per Engine";
            this._MaxPagesPerEngine = this.UninitialisedInteger;
            this.Default_AskBeforeExecute = "N";
            this.Key_AskBeforeExecute = "Ask Before Execute";
            this.Default_ShowSplashScreen = "Y";
            this.Key_ShowSplashScreen = "Show Splash Screen";
            this.Default_ShowTooltips = "Y";
            this.Key_ShowTooltips = "Show Tooltips";
            this.Default_MatchAllTitleWords = "Y";
            this.Key_MatchAllTitleWords = "Match All Title Words";
            this.Default_PageLoadTimeout = 30;
            this.Key_PageLoadTimeout = "Page Load Timeout";
            this._PageLoadTimeout = this.UninitialisedInteger;
            this.Default_SelectedCookieFolder = Environment.GetFolderPath(Environment.SpecialFolder.Cookies);
            this.Key_SelectedCookieFolder = "Selected Cookie Folder";
            this.Default_UserCookieFolder = modGlobal.DefaultCookieFolder;
            this.Key_UserCookieFolder = "User Cookie Folder";
            this.Default_ProxyHost = "";
            this.Key_ProxyHost = "Proxy Host";
            this.Default_WindowWidth = 800;
            this.Key_WindowWidth = "Window Width";
            this._WindowWidth = this.UninitialisedInteger;
            this.Default_WindowHeight = 550;
            this.Key_WindowHeight = "Window Height";
            this._WindowHeight = this.UninitialisedInteger;
            this.Default_WindowState = 0;
            this.Key_WindowState = "Window State";
            this._WindowState = this.UninitialisedInteger;
            this.Default_ProxyPort = 0;
            this.Key_ProxyPort = "Proxy Port";
            this._ProxyPort = this.UninitialisedInteger;
            this.Default_ProxyUsername = "";
            this.Key_ProxyUsername = "Proxy Username";
            this.Default_ProxyPassword = "";
            this.Key_ProxyPassword = "Proxy Password";
            this.Default_CurrentEngines = new string[0];
            this.Key_CurrentEngines = "Current Engines";
            this.Default_CurrentCategory = "Torrents";
            this.Key_CurrentCategory = "Current Category";
            this.Key_CategoryColumns = "Category Columns";
            this.InitialiseRegistry();
        }

        public void InitialiseRegistry()
        {
            RegistryKey key2 = this.RegistryBase();
            if (StringType.StrCmp(key2.GetValue("", "0").ToString(), "0.7b", false) != 0)
            {
                key2.SetValue("", "0.7b");
                key2.SetValue(this.Key_UserCookieFolder, this.Default_UserCookieFolder);
                key2.SetValue(this.Key_SelectedCookieFolder, this.Default_SelectedCookieFolder);
                key2.SetValue(this.Key_ProxyPort, this.Default_ProxyPort);
                key2.SetValue(this.Key_ProxyHost, this.Default_ProxyHost);
                key2.SetValue(this.Key_ProxyUsername, this.Default_ProxyUsername);
                key2.SetValue(this.Key_ProxyPassword, modGlobal.g_oStrings.Encrypt(this.Default_ProxyPassword, "TorrentH"));
                key2.SetValue(this.Key_AskBeforeExecute, this.Default_AskBeforeExecute);
                key2.SetValue(this.Key_WindowWidth, this.Default_WindowWidth);
                key2.SetValue(this.Key_WindowHeight, this.Default_WindowHeight);
                key2.SetValue(this.Key_WindowState, this.Default_WindowState);
                key2.SetValue(this.Key_MaxConcurrentSearches, this.Default_MaxConcurrentSearches);
                key2.SetValue(this.Key_PageLoadTimeout, this.Default_PageLoadTimeout);
                key2.SetValue(this.Key_ShowSplashScreen, this.Default_ShowSplashScreen);
                key2.SetValue(this.Key_ShowTooltips, this.Default_ShowTooltips);
                key2.SetValue(this.Key_MatchAllTitleWords, this.Default_MatchAllTitleWords);
                key2.SetValue(this.Key_CurrentCategory, this.Default_CurrentCategory);
                RegistryKey key = key2.CreateSubKey(this.Key_CategoryColumns);
                string[] strArray = new string[] { "Size", "73", "Filesize", "Engine", "80", "Text" };
                string[] strArray2 = new string[] { "Size", "73", "Filesize", "Engine", "80", "Text", "Server", "70", "Text", "Channel", "70", "Text", "User", "70", "Text" };
                string[] strArray3 = new string[] { 
                    "Size", "73", "Filesize", "Engine", "80", "Text", "Category", "92", "Text", "Date", "79", "Date", "Seeds", "48", "Number", "Peers", 
                    "48", "Number"
                 };
                string[] strArray4 = new string[] { "Engine", "80", "Text" };
                key.SetValue("", strArray);
                key.SetValue("IRC", strArray2);
                key.SetValue("Torrents", strArray3);
                key.SetValue("Torrents (Signup)", strArray3);
                key.SetValue("Torrents (Public)", strArray3);
                key.SetValue("Usenet", strArray4);
                key.Close();
                key = null;
                modGlobal.g_bFirstRun = true;
            }
            key2.Close();
            key2 = null;
        }

        public void ReadCurrentEngines()
        {
            CEngine current;
            using (IEnumerator enumerator = modGlobal.Engines.GetEnumerator())
            {
                while (enumerator.MoveNext())
                {
                    current = (CEngine) enumerator.Current;
                    current.IsCurrentNoSave = false;
                }
            }
            RegistryKey key = this.RegistryBase();
            string[] strArray = (string[]) key.GetValue(this.Key_CurrentEngines);
            key.Close();
            key = null;
            foreach (string str in strArray)
            {
                try
                {
                    current = (CEngine) modGlobal.Engines[str];
                    current.IsCurrentNoSave = true;
                }
                catch (Exception exception1)
                {
                    ProjectData.SetProjectError(exception1);
                    ProjectData.ClearProjectError();
                }
            }
        }

        private RegistryKey RegistryBase()
        {
            return Registry.LocalMachine.CreateSubKey(@"SOFTWARE\\FidoFuz\\Torrent Harvester");
        }

        private RegistryKey RegistryCategoryColumnsBase()
        {
            return Registry.LocalMachine.CreateSubKey(@"SOFTWARE\\FidoFuz\\Torrent Harvester\\" + this.Key_CategoryColumns);
        }

        public void ResetColumns()
        {
            this._CategoryColumns = null;
            this._CategoryAllColumns = null;
        }

        public void SaveCategoryColumns()
        {
            string[] strArray = new string[((this.CategoryColumns.Count * 3) - 1) + 1];
            int num2 = this.CategoryColumns.Count - 1;
            for (int i = 0; i <= num2; i++)
            {
                CColumn column = (CColumn) this.CategoryColumns[i + 1];
                strArray[i * 3] = column.Name;
                strArray[(i * 3) + 1] = column.Width.ToString();
                strArray[(i * 3) + 2] = column.TypeString;
            }
            RegistryKey key = this.RegistryCategoryColumnsBase();
            key.SetValue(this.CurrentCategory, strArray);
            key.Close();
            key = null;
        }

        public void SaveCurrentEngines()
        {
            int num2 = 0;
            foreach (CEngine engine in modGlobal.Engines)
            {
                if (engine.IsCurrent)
                {
                    num2++;
                }
            }
            string[] strArray = new string[(num2 - 1) + 1];
            int index = 0;
            foreach (CEngine engine in modGlobal.Engines)
            {
                if (engine.IsCurrent)
                {
                    strArray[index] = engine.Name;
                    index++;
                }
            }
            RegistryKey key = this.RegistryBase();
            key.SetValue(this.Key_CurrentEngines, strArray);
            key.Close();
            key = null;
        }

        public System.Net.WebProxy WebProxy()
        {
            if (!this.UseProxy)
            {
                System.Net.WebProxy proxy;
                return proxy;
            }
            System.Net.WebProxy proxy2 = new System.Net.WebProxy(this.ProxyHost, this.ProxyPort);
            proxy2.BypassProxyOnLocal = true;
            if (this.ProxyAuthentication)
            {
                proxy2.Credentials = new NetworkCredential(this.ProxyUsername, this.ProxyPassword);
            }
            return proxy2;
        }

        public bool AskBeforeExecute
        {
            get
            {
                if (this._AskBeforeExecute == null)
                {
                    this._AskBeforeExecute = this.get_RegistryString(this.Key_AskBeforeExecute).ToUpper();
                }
                return (StringType.StrCmp(this._AskBeforeExecute, "Y", false) == 0);
            }
            set
            {
                this._AskBeforeExecute = Interaction.IIf(value, "Y", "N").ToString();
                this.set_RegistryString(this.Key_AskBeforeExecute, this._AskBeforeExecute);
            }
        }

        public Collection CategoryAllColumns
        {
            get
            {
                if (this._CategoryAllColumns == null)
                {
                    this._CategoryAllColumns = new Collection();
                    CColumn item = new CColumn("Engine");
                    this._CategoryAllColumns.Add(item, item.Key, null, null);
                    foreach (CEngine engine in this.CategoryEngines)
                    {
                        foreach (CField field in engine.AllFields)
                        {
                            if (((StringType.StrCmp(field.Name, "Title", false) != 0) | (field.Type != CField.EFieldType.ftText)) & !field.Hidden)
                            {
                                CColumn column;
                                try
                                {
                                    column = (CColumn) this._CategoryAllColumns[field.ColumnKey];
                                }
                                catch (Exception exception1)
                                {
                                    ProjectData.SetProjectError(exception1);
                                    column = new CColumn(field.Name);
                                    column.Type = field.Type;
                                    this._CategoryAllColumns.Add(column, column.Key, null, null);
                                    ProjectData.ClearProjectError();
                                }
                                column.Count++;
                            }
                        }
                        item.Count++;
                    }
                }
                return this._CategoryAllColumns;
            }
        }

        public Collection CategoryColumns
        {
            get
            {
                if (this._CategoryColumns == null)
                {
                    this._CategoryColumns = new Collection();
                    RegistryKey key = this.RegistryCategoryColumnsBase();
                    string[] strArray = (string[]) key.GetValue(this.CurrentCategory);
                    key.Close();
                    key = null;
                    bool flag = false;
                    if (strArray != null)
                    {
                        int num2 = ((strArray.GetUpperBound(0) + 1) / 3) - 1;
                        for (int i = 0; i <= num2; i++)
                        {
                            try
                            {
                                CColumn item = new CColumn(strArray[i * 3]);
                                item.TypeString = strArray[(i * 3) + 2];
                                item = (CColumn) this.CategoryAllColumns[item.Key];
                                this._CategoryColumns.Add(item, item.Key, null, null);
                                item.Width = IntegerType.FromString(strArray[(i * 3) + 1]);
                            }
                            catch (Exception exception1)
                            {
                                ProjectData.SetProjectError(exception1);
                                flag = true;
                                ProjectData.ClearProjectError();
                            }
                        }
                    }
                    if (flag)
                    {
                        this.SaveCategoryColumns();
                    }
                }
                return this._CategoryColumns;
            }
            set
            {
                this._CategoryColumns = value;
                this.SaveCategoryColumns();
            }
        }

        public Collection CategoryEngines
        {
            get
            {
                Collection collection2 = new Collection();
                foreach (CEngine engine in modGlobal.Engines)
                {
                    if (engine.BelongsToCategory(this.CurrentCategory))
                    {
                        collection2.Add(engine, engine.Name, null, null);
                    }
                }
                return collection2;
            }
        }

        public string CurrentCategory
        {
            get
            {
                if (this._CurrentCategory == null)
                {
                    this._CurrentCategory = this.get_RegistryString(this.Key_CurrentCategory);
                }
                return this._CurrentCategory;
            }
            set
            {
                this._CurrentCategory = value;
                this._CategoryColumns = null;
                this._CategoryAllColumns = null;
                this.set_RegistryString(this.Key_CurrentCategory, this._CurrentCategory);
            }
        }

        public Font ListFont
        {
            get
            {
                if (this._ListFont == null)
                {
                    TypeConverter converter = TypeDescriptor.GetConverter(typeof(Font));
                    try
                    {
                        this._ListFont = (Font) converter.ConvertFromString(this.get_RegistryString(this.Key_ListFont));
                    }
                    catch (Exception exception1)
                    {
                        ProjectData.SetProjectError(exception1);
                        this._ListFont = (Font) converter.ConvertFromString("Microsoft Sans Serif");
                        ProjectData.ClearProjectError();
                    }
                }
                return this._ListFont;
            }
            set
            {
                this._ListFont = value;
                TypeConverter converter = TypeDescriptor.GetConverter(typeof(Font));
                this.set_RegistryString(this.Key_ListFont, converter.ConvertToString(this._ListFont));
            }
        }

        public bool MatchAllTitleWords
        {
            get
            {
                if (this._MatchAllTitleWords == null)
                {
                    this._MatchAllTitleWords = this.get_RegistryString(this.Key_MatchAllTitleWords).ToUpper();
                }
                return (StringType.StrCmp(this._MatchAllTitleWords, "Y", false) == 0);
            }
            set
            {
                this._MatchAllTitleWords = Interaction.IIf(value, "Y", "N").ToString();
                this.set_RegistryString(this.Key_MatchAllTitleWords, this._MatchAllTitleWords);
            }
        }

        public int MaxConcurrentSearches
        {
            get
            {
                if (this._MaxConcurrentSearches == this.UninitialisedInteger)
                {
                    this._MaxConcurrentSearches = this.get_RegistryInteger(this.Key_MaxConcurrentSearches);
                }
                return this._MaxConcurrentSearches;
            }
            set
            {
                this._MaxConcurrentSearches = value;
                this.set_RegistryInteger(this.Key_MaxConcurrentSearches, this._MaxConcurrentSearches);
            }
        }

        public int MaxPagesPerEngine
        {
            get
            {
                if (this._MaxPagesPerEngine == this.UninitialisedInteger)
                {
                    this._MaxPagesPerEngine = this.get_RegistryInteger(this.Key_MaxPagesPerEngine);
                }
                return this._MaxPagesPerEngine;
            }
            set
            {
                this._MaxPagesPerEngine = value;
                this.set_RegistryInteger(this.Key_MaxPagesPerEngine, this._MaxPagesPerEngine);
            }
        }

        public int MaxResultsPerEngine
        {
            get
            {
                if (this._MaxResultsPerEngine == this.UninitialisedInteger)
                {
                    this._MaxResultsPerEngine = this.get_RegistryInteger(this.Key_MaxResultsPerEngine);
                }
                return this._MaxResultsPerEngine;
            }
            set
            {
                this._MaxResultsPerEngine = value;
                this.set_RegistryInteger(this.Key_MaxResultsPerEngine, this._MaxResultsPerEngine);
            }
        }

        public int PageLoadTimeout
        {
            get
            {
                if (this._PageLoadTimeout == this.UninitialisedInteger)
                {
                    this._PageLoadTimeout = this.get_RegistryInteger(this.Key_PageLoadTimeout);
                }
                return this._PageLoadTimeout;
            }
            set
            {
                this._PageLoadTimeout = value;
                this.set_RegistryInteger(this.Key_PageLoadTimeout, this._PageLoadTimeout);
            }
        }

        public bool ProxyAuthentication
        {
            get
            {
                return (this.ProxyUsername.Length != 0);
            }
            set
            {
                if (!value)
                {
                    this.ProxyUsername = "";
                    this.ProxyPassword = "";
                }
            }
        }

        public string ProxyHost
        {
            get
            {
                if (this._ProxyHost == null)
                {
                    this._ProxyHost = this.get_RegistryString(this.Key_ProxyHost);
                }
                return this._ProxyHost;
            }
            set
            {
                this._ProxyHost = value;
                this.set_RegistryString(this.Key_ProxyHost, this._ProxyHost);
            }
        }

        public string ProxyPassword
        {
            get
            {
                if (this._ProxyPassword == null)
                {
                    this._ProxyPassword = modGlobal.g_oStrings.Decrypt(this.get_RegistryString(this.Key_ProxyPassword), "TorrentH");
                }
                return this._ProxyPassword;
            }
            set
            {
                this._ProxyPassword = value;
                this.set_RegistryString(this.Key_ProxyPassword, modGlobal.g_oStrings.Encrypt(this._ProxyPassword, "TorrentH"));
            }
        }

        public int ProxyPort
        {
            get
            {
                if (this._ProxyPort == this.UninitialisedInteger)
                {
                    this._ProxyPort = this.get_RegistryInteger(this.Key_ProxyPort);
                }
                return this._ProxyPort;
            }
            set
            {
                this._ProxyPort = value;
                this.set_RegistryString(this.Key_ProxyPort, this._ProxyPort.ToString());
            }
        }

        public string ProxyUsername
        {
            get
            {
                if (this._ProxyUsername == null)
                {
                    this._ProxyUsername = this.get_RegistryString(this.Key_ProxyUsername);
                }
                return this._ProxyUsername;
            }
            set
            {
                this._ProxyUsername = value;
                this.set_RegistryString(this.Key_ProxyUsername, this._ProxyUsername);
            }
        }

        public Color this[string strKey]
        {
            get
            {
                RegistryKey key2 = this.RegistryBase();
                Color color2 = Color.FromKnownColor((KnownColor) Enum.Parse(typeof(KnownColor), key2.GetValue(strKey).ToString()));
                key2.Close();
                key2 = null;
                return color2;
            }
            set
            {
                RegistryKey key = this.RegistryBase();
                key.SetValue(strKey, value.Name);
                key.Close();
                key = null;
            }
        }
                
        public string SelectedCookieFolder
        {
            get
            {
                if (this._SelectedCookieFolder == null)
                {
                    this._SelectedCookieFolder = this.get_RegistryString(this.Key_SelectedCookieFolder);
                }
                return this._SelectedCookieFolder;
            }
            set
            {
                this._SelectedCookieFolder = value;
                this.set_RegistryString(this.Key_SelectedCookieFolder, this._SelectedCookieFolder);
            }
        }

        public bool ShowSplashScreen
        {
            get
            {
                if (this._ShowSplashScreen == null)
                {
                    this._ShowSplashScreen = this.get_RegistryString(this.Key_ShowSplashScreen).ToUpper();
                }
                return (StringType.StrCmp(this._ShowSplashScreen, "Y", false) == 0);
            }
            set
            {
                this._ShowSplashScreen = Interaction.IIf(value, "Y", "N").ToString();
                this.set_RegistryString(this.Key_ShowSplashScreen, this._ShowSplashScreen);
            }
        }

        public bool ShowTooltips
        {
            get
            {
                if (this._ShowTooltips == null)
                {
                    this._ShowTooltips = this.get_RegistryString(this.Key_ShowTooltips).ToUpper();
                }
                return (StringType.StrCmp(this._ShowTooltips, "Y", false) == 0);
            }
            set
            {
                this._ShowTooltips = Interaction.IIf(value, "Y", "N").ToString();
                this.set_RegistryString(this.Key_ShowTooltips, this._ShowTooltips);
            }
        }

        public bool UseProxy
        {
            get
            {
                return (this.ProxyHost.Length != 0);
            }
            set
            {
                if (!value)
                {
                    this.ProxyHost = "";
                    this.ProxyPort = 0;
                    this.ProxyAuthentication = false;
                }
            }
        }

        public string UserCookieFolder
        {
            get
            {
                if (this._UserCookieFolder == null)
                {
                    this._UserCookieFolder = this.get_RegistryString(this.Key_UserCookieFolder);
                }
                return this._UserCookieFolder;
            }
            set
            {
                this._UserCookieFolder = value;
                this.set_RegistryString(this.Key_UserCookieFolder, this._UserCookieFolder);
            }
        }

        public int WindowHeight
        {
            get
            {
                if (this._WindowHeight == this.UninitialisedInteger)
                {
                    this._WindowHeight = this.get_RegistryInteger(this.Key_WindowHeight);
                }
                return this._WindowHeight;
            }
            set
            {
                this._WindowHeight = value;
                this.set_RegistryInteger(this.Key_WindowHeight, this._WindowHeight);
            }
        }

        public FormWindowState WindowState
        {
            get
            {
                if (this._WindowState == this.UninitialisedInteger)
                {
                    this._WindowState = this.get_RegistryInteger(this.Key_WindowState);
                }
                return (FormWindowState) this._WindowState;
            }
            set
            {
                this._WindowState = (int) value;
                this.set_RegistryInteger(this.Key_WindowState, this._WindowState);
            }
        }

        public int WindowWidth
        {
            get
            {
                if (this._WindowWidth == this.UninitialisedInteger)
                {
                    this._WindowWidth = this.get_RegistryInteger(this.Key_WindowWidth);
                }
                return this._WindowWidth;
            }
            set
            {
                this._WindowWidth = value;
                this.set_RegistryInteger(this.Key_WindowWidth, this._WindowWidth);
            }
        }
    }
}

