﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using Microsoft.VisualBasic.CompilerServices;
    using System;
    using System.IO;
    using System.Security.Cryptography;
    using System.Text;

    public class CStrings
    {
        public string ConvertCRLF(string strText)
        {
            if (StringType.StrCmp(strText, "", false) != 0)
            {
                int index = strText.IndexOf('\n', 2);
                if ((index != -1) && (strText[index - 1] != '\r'))
                {
                    strText = strText.Replace("\n", "\r\n");
                }
            }
            return strText;
        }

        public string CRLFTrim(string strSource)
        {
            strSource = strSource.Trim();
            while (strSource.StartsWith("\r") | strSource.StartsWith("\n"))
            {
                strSource = strSource.Substring(1);
            }
            while (strSource.EndsWith("\r") | strSource.EndsWith("\n"))
            {
                strSource = strSource.Substring(0, strSource.Length - 1);
            }
            return strSource;
        }

        public string Decrypt(string strText, string strKey)
        {
            byte[] rgbKey = new byte[0];
            byte[] rgbIV = new byte[] { 0x12, 0x34, 0x56, 120, 0x90, 0xab, 0xcd, 0xef };
            byte[] buffer = new byte[strText.Length + 1];
            rgbKey = Encoding.UTF8.GetBytes(strKey.PadRight(8).Substring(0, 8));
            DESCryptoServiceProvider provider = new DESCryptoServiceProvider();
            buffer = Convert.FromBase64String(strText);
            MemoryStream stream2 = new MemoryStream();
            CryptoStream stream = new CryptoStream(stream2, provider.CreateDecryptor(rgbKey, rgbIV), CryptoStreamMode.Write);
            stream.Write(buffer, 0, buffer.Length);
            stream.FlushFinalBlock();
            return Encoding.UTF8.GetString(stream2.ToArray());
        }

        public string Encrypt(string strText, string strKey)
        {
            byte[] rgbKey = new byte[0];
            byte[] rgbIV = new byte[] { 0x12, 0x34, 0x56, 120, 0x90, 0xab, 0xcd, 0xef };
            rgbKey = Encoding.UTF8.GetBytes(strKey.PadRight(8).Substring(0, 8));
            DESCryptoServiceProvider provider = new DESCryptoServiceProvider();
            byte[] bytes = Encoding.UTF8.GetBytes(strText);
            MemoryStream stream2 = new MemoryStream();
            CryptoStream stream = new CryptoStream(stream2, provider.CreateEncryptor(rgbKey, rgbIV), CryptoStreamMode.Write);
            stream.Write(bytes, 0, bytes.Length);
            stream.FlushFinalBlock();
            return Convert.ToBase64String(stream2.ToArray());
        }

        public int FindNext(string strData, string strFindChars, int intStartAt)
        {
            int falsePart = 0x7fffffff;
            CharEnumerator enumerator = strFindChars.GetEnumerator();
            while (enumerator.MoveNext())
            {
                char current = enumerator.Current;
                int index = strData.IndexOf(current, intStartAt);
                if ((index != -1) && (index < falsePart))
                {
                    falsePart = index;
                }
            }
            return IntegerType.FromObject(Interaction.IIf(falsePart == 0x7fffffff, -1, falsePart));
        }

        public string FixFilename(string strFilename)
        {
            string str2 = "";
            if (strFilename == null)
            {
                strFilename = "#";
            }
            else
            {
                strFilename = strFilename.Trim();
            }
            CharEnumerator enumerator = strFilename.GetEnumerator();
            while (enumerator.MoveNext())
            {
                char current = enumerator.Current;
                switch (current)
                {
                    case '\\':
                        current = '#';
                        break;

                    case '/':
                        current = '#';
                        break;

                    case ':':
                        current = '#';
                        break;

                    case '*':
                        current = '#';
                        break;

                    case '?':
                        current = '#';
                        break;

                    case '"':
                        current = '#';
                        break;

                    case '<':
                        current = '#';
                        break;

                    case '>':
                        current = '#';
                        break;

                    case '|':
                        current = '#';
                        break;

                    default:
                        if (char.IsControl(current))
                        {
                            current = '#';
                        }
                        break;
                }
                str2 = str2 + StringType.FromChar(current);
            }
            if (str2.StartsWith("."))
            {
                str2 = "#" + str2;
            }
            return str2;
        }

        public string StripHTMLTags(string strHTML)
        {
            int num = 0;
            string expression = "";
            while (num < strHTML.Length)
            {
                bool flag;
                char ch = strHTML[num];
                if (flag)
                {
                    if (StringType.StrCmp(StringType.FromChar(ch), "\"", false) == 0)
                    {
                        flag = false;
                    }
                }
                else
                {
                    bool flag2;
                    if (!flag2)
                    {
                        if (ch == '<')
                        {
                            flag2 = true;
                        }
                        else
                        {
                            expression = expression + StringType.FromChar(ch);
                        }
                    }
                    else
                    {
                        switch (ch)
                        {
                            case '"':
                                flag = true;
                                goto Label_0064;

                            case '>':
                                flag2 = false;
                                goto Label_0064;
                        }
                    }
                }
            Label_0064:
                num++;
            }
            if (expression.IndexOf('&') != -1)
            {
                expression = Strings.Replace(Strings.Replace(Strings.Replace(Strings.Replace(Strings.Replace(Strings.Replace(expression, "&amp;", "&", 1, -1, CompareMethod.Binary), "&quot;", "\"", 1, -1, CompareMethod.Binary), "&lt;", "<", 1, -1, CompareMethod.Binary), "&gt;", ">", 1, -1, CompareMethod.Binary), "&#x200B;", "", 1, -1, CompareMethod.Binary), "&#039;", "'", 1, -1, CompareMethod.Binary);
            }
            return expression;
        }
    }
}

