﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using Microsoft.VisualBasic.CompilerServices;
    using System;
    using System.Collections.Specialized;
    using System.Globalization;

    public class CTextTransform
    {
        private ETransformType _ActionType;
        private NameValueCollection _Variables;

        public void ClearVariables()
        {
            this._Variables = new NameValueCollection();
        }

        public void Init_AddValue()
        {
            this.ClearVariables();
            this.set_Variable("value", "0");
        }

        public void Init_ConvertFilesizeToMB()
        {
            this.ClearVariables();
        }

        public void Init_Copy()
        {
            this.ClearVariables();
            this.set_Variable("count", "");
        }

        public void Init_CopyReverse()
        {
            this.ClearVariables();
            this.set_Variable("count", "");
        }

        public void Init_CopyTo()
        {
            this.ClearVariables();
            this.set_Variable("text", "");
        }

        public void Init_CopyToReverse()
        {
            this.ClearVariables();
            this.set_Variable("text", "");
        }

        public void Init_Cut()
        {
            this.ClearVariables();
            this.set_Variable("count", "");
        }

        public void Init_CutReverse()
        {
            this.ClearVariables();
            this.set_Variable("count", "");
        }

        public void Init_CutTo()
        {
            this.ClearVariables();
            this.set_Variable("text", "");
        }

        public void Init_CutToReverse()
        {
            this.ClearVariables();
            this.set_Variable("text", "");
        }

        public void Init_DateDifference()
        {
            this.ClearVariables();
        }

        public void Init_ErrorHandler()
        {
            this.ClearVariables();
        }

        public void Init_FormatDate()
        {
            this.ClearVariables();
            this.set_Variable("mask", "");
        }

        public void Init_Insert()
        {
            this.ClearVariables();
            this.set_Variable("text", "");
        }

        public void Init_InsertTodaysDate()
        {
            this.ClearVariables();
        }

        public void Init_Paste()
        {
            this.ClearVariables();
        }

        public void Init_PositionAfter()
        {
            this.ClearVariables();
            this.set_Variable("text", "");
            this.set_Variable("count", "");
        }

        public void Init_PositionAfterReverse()
        {
            this.ClearVariables();
            this.set_Variable("text", "");
            this.set_Variable("count", "");
        }

        public void Init_PositionAt()
        {
            this.ClearVariables();
            this.set_Variable("text", "");
            this.set_Variable("count", "");
        }

        public void Init_PositionAtReverse()
        {
            this.ClearVariables();
            this.set_Variable("text", "");
            this.set_Variable("count", "");
        }

        public void Init_PositionDecrement()
        {
            this.ClearVariables();
            this.set_Variable("count", "");
        }

        public void Init_PositionIncrement()
        {
            this.ClearVariables();
            this.set_Variable("count", "");
        }

        public void Init_RemoveBoundingQuotes()
        {
            this.ClearVariables();
        }

        public void Init_RemoveControlCharacters()
        {
            this.ClearVariables();
        }

        public void Init_Replace()
        {
            this.ClearVariables();
            this.set_Variable("from", "");
            this.set_Variable("to", "");
        }

        public void Init_Restore()
        {
            this.ClearVariables();
        }

        public void Init_StripHTML()
        {
            this.ClearVariables();
        }

        public void Init_TextBetween()
        {
            this.ClearVariables();
            this.set_Variable("from", "");
            this.set_Variable("to", "");
        }

        public void Init_TextIfBlank()
        {
            this.ClearVariables();
            this.set_Variable("text", "");
        }

        public void Init_TextTo()
        {
            this.ClearVariables();
            this.set_Variable("text", "");
        }

        public void Init_TextToReverse()
        {
            this.ClearVariables();
            this.set_Variable("text", "");
        }

        public void Init_Trim()
        {
            this.ClearVariables();
        }

        public void Load(CXMLNode oXMLNode)
        {
            this.Name = oXMLNode.Name;
            StringEnumerator enumerator = oXMLNode.AttributeNames.GetEnumerator();
            while (enumerator.MoveNext())
            {
                string current = enumerator.Current;
                this.set_Variable(current, oXMLNode.get_StringAttribute(current, ""));
            }
        }

        public bool Perform(ref string strText, ref int intPos, ref string strClipboard)
        {
            bool flag;
            switch (this._ActionType)
            {
                case ETransformType.ttStripHTML:
                    return this.Perform_StripHTML(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttReplace:
                    return this.Perform_Replace(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttPositionAt:
                    return this.Perform_PositionAt(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttPositionAtReverse:
                    return this.Perform_PositionAtReverse(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttPositionAfter:
                    return this.Perform_PositionAfter(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttPositionAfterReverse:
                    return this.Perform_PositionAfterReverse(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttPositionAtStart:
                case ETransformType.ttPositionAtEnd:
                    return flag;

                case ETransformType.ttCutTo:
                    return this.Perform_CutTo(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttCutToReverse:
                    return this.Perform_CutToReverse(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttCut:
                    return this.Perform_Cut(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttCutReverse:
                    return this.Perform_CutReverse(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttCopyTo:
                    return this.Perform_CopyTo(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttCopyToReverse:
                    return this.Perform_CopyToReverse(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttCopy:
                    return this.Perform_Copy(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttCopyReverse:
                    return this.Perform_CopyReverse(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttPaste:
                    return this.Perform_Paste(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttInsert:
                    return this.Perform_Insert(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttTextTo:
                    return this.Perform_TextTo(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttTextToReverse:
                    return this.Perform_TextToReverse(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttTextBetween:
                    return this.Perform_TextBetween(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttTrim:
                    return this.Perform_Trim(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttRemoveBoundingQuotes:
                    return this.Perform_RemoveBoundingQuotes(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttRemoveControlCharacters:
                    return this.Perform_RemoveControlCharacters(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttPositionIncrement:
                    return this.Perform_PositionIncrement(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttPositionDecrement:
                    return this.Perform_PositionDecrement(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttTextIfBlank:
                    return this.Perform_TextIfBlank(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttRestore:
                    return true;

                case ETransformType.ttFormatDate:
                    return this.Perform_FormatDate(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttDateDifference:
                    return this.Perform_DateDifference(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttInsertTodaysDate:
                    return this.Perform_InsertTodaysDate(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttConvertFilesizeToMB:
                    return this.Perform_ConvertFilesizeToMB(ref strText, ref intPos, ref strClipboard);

                case ETransformType.ttErrorHandler:
                    return true;

                case ETransformType.ttAddValue:
                    return this.Perform_AddValue(ref strText, ref intPos, ref strClipboard);
            }
            return flag;
        }

        private bool Perform_AddValue(ref string strSource, ref int intPos, ref string strClipboard)
        {
            bool flag;
            string str = this.get_Variable("value");
            try
            {
                strSource = (IntegerType.FromString(strSource) + IntegerType.FromString(str)).ToString();
                intPos = 0;
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                strSource = "";
                ProjectData.ClearProjectError();
            }
            return flag;
        }

        private bool Perform_ConvertFilesizeToMB(ref string strSource, ref int intPos, ref string strClipboard)
        {
            bool flag;
            try
            {
                double num;
                if (strSource.EndsWith("GB"))
                {
                    num = DoubleType.FromString(strSource.Substring(0, strSource.Length - 2).Trim()) * 1000.0;
                }
                else if (strSource.EndsWith("MB"))
                {
                    num = DoubleType.FromString(strSource.Substring(0, strSource.Length - 2).Trim());
                }
                else if (strSource.EndsWith("KB"))
                {
                    num = DoubleType.FromString(strSource.Substring(0, strSource.Length - 2).Trim()) / 1000.0;
                }
                else
                {
                    num = DoubleType.FromString(strSource);
                }
                strSource = num.ToString();
                return true;
                intPos = 0;
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                flag = false;
                ProjectData.ClearProjectError();
                return flag;
                ProjectData.ClearProjectError();
            }
            return flag;
        }

        private bool Perform_Copy(ref string strSource, ref int intPos, ref string strClipboard)
        {
            int length = modGlobal.ConvInt(this.get_Variable("count"), 1);
            if ((intPos + length) > strSource.Length)
            {
                return false;
            }
            strClipboard = strSource.Substring(intPos, length);
            return true;
        }

        private bool Perform_CopyReverse(ref string strSource, ref int intPos, ref string strClipboard)
        {
            int length = modGlobal.ConvInt(this.get_Variable("count"), 1);
            if (length > intPos)
            {
                return false;
            }
            strClipboard = strSource.Substring(intPos - length, length);
            return true;
        }

        private bool Perform_CopyTo(ref string strSource, ref int intPos, ref string strClipboard)
        {
            int length;
            string sLeft = this.get_Variable("text");
            if (StringType.StrCmp(sLeft, "", false) == 0)
            {
                length = strSource.Length;
            }
            else
            {
                length = strSource.IndexOf(sLeft, intPos);
            }
            if (length == -1)
            {
                return false;
            }
            strClipboard = strSource.Substring(intPos, length - intPos);
            return true;
        }

        private bool Perform_CopyToReverse(ref string strSource, ref int intPos, ref string strClipboard)
        {
            int num;
            string sLeft = this.get_Variable("text");
            if (StringType.StrCmp(sLeft, "", false) == 0)
            {
                num = 0;
            }
            else
            {
                num = strSource.LastIndexOf(sLeft, intPos);
            }
            if (num == -1)
            {
                return false;
            }
            strClipboard = strSource.Substring(num, intPos - num);
            return true;
        }

        private bool Perform_Cut(ref string strSource, ref int intPos, ref string strClipboard)
        {
            int length = modGlobal.ConvInt(this.get_Variable("count"), 1);
            if ((intPos + length) > strSource.Length)
            {
                return false;
            }
            strClipboard = strSource.Substring(intPos, length);
            strSource = strSource.Remove(intPos, length);
            return true;
        }

        private bool Perform_CutReverse(ref string strSource, ref int intPos, ref string strClipboard)
        {
            int length = modGlobal.ConvInt(this.get_Variable("count"), 1);
            if (length > intPos)
            {
                return false;
            }
            strClipboard = strSource.Substring(intPos - length, length);
            strSource = strSource.Remove(intPos - length, length);
            intPos -= length;
            return true;
        }

        private bool Perform_CutTo(ref string strSource, ref int intPos, ref string strClipboard)
        {
            int length;
            string sLeft = this.get_Variable("text");
            if (StringType.StrCmp(sLeft, "", false) == 0)
            {
                length = strSource.Length;
            }
            else
            {
                length = strSource.IndexOf(sLeft, intPos);
            }
            if (length == -1)
            {
                return false;
            }
            strClipboard = strSource.Substring(intPos, length - intPos);
            strSource = strSource.Remove(intPos, length - intPos);
            return true;
        }

        private bool Perform_CutToReverse(ref string strSource, ref int intPos, ref string strClipboard)
        {
            int num;
            string sLeft = this.get_Variable("text");
            if (StringType.StrCmp(sLeft, "", false) == 0)
            {
                num = 0;
            }
            else
            {
                num = strSource.LastIndexOf(sLeft, intPos);
            }
            if (num == -1)
            {
                return false;
            }
            strClipboard = strSource.Substring(num, intPos - num);
            strSource = strSource.Remove(num, intPos - num);
            intPos = num;
            return true;
        }

        private bool Perform_DateDifference(ref string strSource, ref int intPos, ref string strClipboard)
        {
            bool flag2;
            DateTime now = DateAndTime.Now;
            try
            {
                bool flag;
                now = now.AddSeconds((double) (0 - now.Second));
                int startIndex = 0;
                int index = strSource.IndexOf("w", startIndex);
                if (index != -1)
                {
                    now = now.AddDays(7.0 * -DoubleType.FromString(strSource.Substring(startIndex, index - startIndex)));
                    startIndex = index + 1;
                }
                index = strSource.IndexOf("d", startIndex);
                if (index != -1)
                {
                    now = now.AddDays(-DoubleType.FromString(strSource.Substring(startIndex, index - startIndex)));
                    startIndex = index + 1;
                }
                index = strSource.IndexOf("h", startIndex);
                if (index != -1)
                {
                    now = now.AddHours(-DoubleType.FromString(strSource.Substring(startIndex, index - startIndex)));
                    startIndex = index + 1;
                    flag = true;
                }
                else
                {
                    now = now.AddMinutes((double) (0 - now.Minute));
                    flag = false;
                }
                index = strSource.IndexOf("m", startIndex);
                if (index != -1)
                {
                    now = now.AddMinutes(-DoubleType.FromString(strSource.Substring(startIndex, index - startIndex)));
                    startIndex = index + 1;
                }
                else if (!flag)
                {
                    now = now.AddHours((double) (0 - now.Hour));
                }
                strSource = now.ToString();
                intPos = 0;
                flag2 = true;
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                Exception exception = exception1;
                strSource = "";
                flag2 = false;
                ProjectData.ClearProjectError();
                return flag2;
                ProjectData.ClearProjectError();
            }
            return flag2;
        }

        private bool Perform_FormatDate(ref string strSource, ref int intPos, ref string strClipboard)
        {
            bool flag;
            string sLeft = this.get_Variable("mask");
            try
            {
                DateTime time;
                if (StringType.StrCmp(sLeft, "", false) == 0)
                {
                    time = DateTime.Parse(strSource);
                }
                else
                {
                    CultureInfo provider = new CultureInfo("", true);
                    provider.DateTimeFormat.ShortDatePattern = sLeft;
                    time = DateTime.ParseExact(strSource, "d", provider, DateTimeStyles.NoCurrentDateDefault);
                }
                if (DateTime.Compare(time, DateAndTime.Today.AddDays(2.0)) > 0)
                {
                    time = time.AddYears(-1);
                }
                strSource = time.ToString();
                intPos = 0;
                flag = true;
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                Exception exception = exception1;
                strSource = "";
                flag = false;
                ProjectData.ClearProjectError();
                return flag;
                ProjectData.ClearProjectError();
            }
            return flag;
        }

        private bool Perform_Insert(ref string strSource, ref int intPos, ref string strClipboard)
        {
            string str = this.get_Variable("text");
            strSource = strSource.Insert(intPos, str);
            intPos += str.Length;
            return true;
        }

        private bool Perform_InsertTodaysDate(ref string strSource, ref int intPos, ref string strClipboard)
        {
            bool flag;
            string str = DateAndTime.Today.ToString();
            try
            {
                strSource = strSource.Insert(intPos, str);
                intPos += str.Length;
                flag = true;
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                flag = false;
                ProjectData.ClearProjectError();
                return flag;
                ProjectData.ClearProjectError();
            }
            return flag;
        }

        private bool Perform_Paste(ref string strSource, ref int intPos, ref string strClipboard)
        {
            strSource = strSource.Insert(intPos, strClipboard);
            intPos += strClipboard.Length;
            return true;
        }

        private bool Perform_PositionAfter(ref string strSource, ref int intPos, ref string strClipboard)
        {
            string sLeft = this.get_Variable("text");
            int num = modGlobal.ConvInt(this.get_Variable("count"), 1);
            int num2 = intPos;
            if (StringType.StrCmp(sLeft, "", false) == 0)
            {
                intPos = 0;
            }
            else
            {
                do
                {
                    intPos = strSource.IndexOf(sLeft, intPos);
                    num--;
                    if (intPos != -1)
                    {
                        intPos += sLeft.Length;
                    }
                }
                while (!((intPos == -1) | (num == 0)));
            }
            if (intPos == -1)
            {
                intPos = num2;
                return false;
            }
            return true;
        }

        private bool Perform_PositionAfterReverse(ref string strSource, ref int intPos, ref string strClipboard)
        {
            string sLeft = this.get_Variable("text");
            int num = modGlobal.ConvInt(this.get_Variable("count"), 1);
            int num2 = intPos;
            if (StringType.StrCmp(sLeft, "", false) == 0)
            {
                intPos = strSource.Length;
            }
            else
            {
                do
                {
                    intPos = strSource.LastIndexOf(sLeft, intPos);
                    num--;
                    if ((intPos != -1) & (num != 0))
                    {
                        intPos--;
                    }
                }
                while (!((intPos == -1) | (num == 0)));
                if (intPos != -1)
                {
                    intPos += sLeft.Length;
                }
            }
            if (intPos == -1)
            {
                intPos = num2;
                return false;
            }
            return true;
        }

        private bool Perform_PositionAt(ref string strSource, ref int intPos, ref string strClipboard)
        {
            string sLeft = this.get_Variable("text");
            int num = modGlobal.ConvInt(this.get_Variable("count"), 1);
            int num2 = intPos;
            if (StringType.StrCmp(sLeft, "", false) == 0)
            {
                intPos = 0;
            }
            else
            {
                do
                {
                    intPos = strSource.IndexOf(sLeft, intPos);
                    num--;
                    if ((intPos != -1) & (num != 0))
                    {
                        intPos += sLeft.Length;
                    }
                }
                while (!((intPos == -1) | (num == 0)));
            }
            if (intPos == -1)
            {
                intPos = num2;
                return false;
            }
            return true;
        }

        private bool Perform_PositionAtReverse(ref string strSource, ref int intPos, ref string strClipboard)
        {
            string sLeft = this.get_Variable("text");
            int num = modGlobal.ConvInt(this.get_Variable("count"), 1);
            int num2 = intPos;
            if (StringType.StrCmp(sLeft, "", false) == 0)
            {
                intPos = strSource.Length;
            }
            else
            {
                do
                {
                    intPos = strSource.LastIndexOf(sLeft, intPos);
                    num--;
                    if ((intPos != -1) & (num != 0))
                    {
                        intPos--;
                    }
                }
                while (!((intPos == -1) | (num == 0)));
            }
            if (intPos == -1)
            {
                intPos = num2;
                return false;
            }
            return true;
        }

        private bool Perform_PositionDecrement(ref string strSource, ref int intPos, ref string strClipboard)
        {
            int num = modGlobal.ConvInt(this.get_Variable("count"), 1);
            if ((intPos - num) >= 0)
            {
                intPos -= num;
                return true;
            }
            return false;
        }

        private bool Perform_PositionIncrement(ref string strSource, ref int intPos, ref string strClipboard)
        {
            int num = modGlobal.ConvInt(this.get_Variable("count"), 1);
            if ((intPos + num) <= strSource.Length)
            {
                intPos += num;
                return true;
            }
            return false;
        }

        private bool Perform_RemoveBoundingQuotes(ref string strSource, ref int intPos, ref string strClipboard)
        {
            if (strSource.StartsWith("\"") & strSource.EndsWith("\""))
            {
                strSource = strSource.Substring(1, strSource.Length - 2);
                intPos--;
            }
            return true;
        }

        private bool Perform_RemoveControlCharacters(ref string strSource, ref int intPos, ref string strClipboard)
        {
            string str = "";
            CharEnumerator enumerator = strSource.GetEnumerator();
            while (enumerator.MoveNext())
            {
                char current = enumerator.Current;
                if (Strings.Asc(current) >= 0x20)
                {
                    str = str + StringType.FromChar(current);
                }
            }
            strSource = str;
            intPos = 0;
            return true;
        }

        private bool Perform_Replace(ref string strSource, ref int intPos, ref string strClipboard)
        {
            string sLeft = this.get_Variable("from");
            string newValue = this.get_Variable("to");
            if (StringType.StrCmp(sLeft, "", false) != 0)
            {
                strSource = strSource.Replace(sLeft, newValue);
                intPos = 0;
            }
            return true;
        }

        private bool Perform_StripHTML(ref string strSource, ref int intPos, ref string strClipboard)
        {
            strSource = modGlobal.g_oStrings.StripHTMLTags(strSource);
            intPos = 0;
            return true;
        }

        private bool Perform_TextBetween(ref string strSource, ref int intPos, ref string strClipboard)
        {
            int length;
            int index;
            string sLeft = this.get_Variable("from");
            string str2 = this.get_Variable("to");
            if (StringType.StrCmp(sLeft, "", false) == 0)
            {
                index = intPos;
                sLeft = "";
            }
            else
            {
                index = strSource.IndexOf(sLeft, intPos);
            }
            if (index == -1)
            {
                return false;
            }
            index += sLeft.Length;
            if (StringType.StrCmp(str2, "", false) == 0)
            {
                length = strSource.Length;
            }
            else
            {
                length = strSource.IndexOf(str2, index);
            }
            if (length == -1)
            {
                return false;
            }
            strSource = strSource.Substring(index, length - index);
            intPos = 0;
            return true;
        }

        private bool Perform_TextIfBlank(ref string strSource, ref int intPos, ref string strClipboard)
        {
            string str = this.get_Variable("text");
            if (StringType.StrCmp(strSource, "", false) == 0)
            {
                strSource = str;
                intPos = 0;
            }
            return true;
        }

        private bool Perform_TextTo(ref string strSource, ref int intPos, ref string strClipboard)
        {
            string str = this.get_Variable("text");
            int index = strSource.IndexOf(str, intPos);
            if (index == -1)
            {
                return false;
            }
            strSource = strSource.Substring(intPos, index - intPos);
            intPos = 0;
            return true;
        }

        private bool Perform_TextToReverse(ref string strSource, ref int intPos, ref string strClipboard)
        {
            string str = this.get_Variable("text");
            int num = strSource.LastIndexOf(str, intPos - 1);
            if (StringType.StrCmp(str, "", false) == 0)
            {
                num = 0;
            }
            if (num == -1)
            {
                return false;
            }
            strSource = strSource.Substring(num + 1, (intPos - num) - 1);
            intPos = 0;
            return true;
        }

        private bool Perform_Trim(ref string strSource, ref int intPos, ref string strClipboard)
        {
            strSource = strSource.Trim();
            intPos = 0;
            return true;
        }

        public void Save(CXMLNode oXMLNode)
        {
            CXMLNode node = oXMLNode.Create(this.Name);
            int num2 = this.NumVariables - 1;
            for (int i = 0; i <= num2; i++)
            {
                node.AddAttribute(this.get_VariableName(i), this.get_Variable(i), false);
            }
            node = null;
        }

        public void Set_AddValue(int intValue)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttAddValue;
            this.set_Variable("value", StringType.FromInteger(intValue));
        }

        public void Set_ConvertFilesizeToMB()
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttConvertFilesizeToMB;
        }

        public void Set_Copy(string strText, int intCount)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttCopy;
            if (intCount == 1)
            {
                this.set_Variable("count", "");
            }
            else
            {
                this.set_Variable("count", intCount.ToString());
            }
        }

        public void Set_CopyReverse(string strText, int intCount)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttCopyReverse;
            if (intCount == 1)
            {
                this.set_Variable("count", "");
            }
            else
            {
                this.set_Variable("count", intCount.ToString());
            }
        }

        public void Set_CopyTo(string strText)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttCopyTo;
            this.set_Variable("text", strText);
        }

        public void Set_CopyToReverse(string strText)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttCopyToReverse;
            this.set_Variable("text", strText);
        }

        public void Set_Cut(string strText, int intCount)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttCut;
            if (intCount == 1)
            {
                this.set_Variable("count", "");
            }
            else
            {
                this.set_Variable("count", intCount.ToString());
            }
        }

        public void Set_CutReverse(string strText, int intCount)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttCutReverse;
            if (intCount == 1)
            {
                this.set_Variable("count", "");
            }
            else
            {
                this.set_Variable("count", intCount.ToString());
            }
        }

        public void Set_CutTo(string strText)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttCutTo;
            this.set_Variable("text", strText);
        }

        public void Set_CutToReverse(string strText)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttCutToReverse;
            this.set_Variable("text", strText);
        }

        public void Set_DateDifference()
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttDateDifference;
        }

        public void Set_ErrorHandler()
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttErrorHandler;
        }

        public void Set_FormatDate(string strMask)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttFormatDate;
            this.set_Variable("mask", strMask);
        }

        public void Set_Insert(string strText)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttInsert;
            this.set_Variable("text", strText);
        }

        public void Set_InsertTodaysDate()
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttInsertTodaysDate;
        }

        public void Set_Paste(string strText)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttPaste;
        }

        public void Set_PositionAfter(string strText, int intCount)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttPositionAfter;
            this.set_Variable("text", strText);
            if (intCount == 1)
            {
                this.set_Variable("count", "");
            }
            else
            {
                this.set_Variable("count", intCount.ToString());
            }
        }

        public void Set_PositionAfterReverse(string strText, int intCount)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttPositionAfterReverse;
            this.set_Variable("text", strText);
            if (intCount == 1)
            {
                this.set_Variable("count", "");
            }
            else
            {
                this.set_Variable("count", intCount.ToString());
            }
        }

        public void Set_PositionAt(string strText, int intCount)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttPositionAt;
            this.set_Variable("text", strText);
            if (intCount == 1)
            {
                this.set_Variable("count", "");
            }
            else
            {
                this.set_Variable("count", intCount.ToString());
            }
        }

        public void Set_PositionAtReverse(string strText, int intCount)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttPositionAtReverse;
            this.set_Variable("text", strText);
            if (intCount == 1)
            {
                this.set_Variable("count", "");
            }
            else
            {
                this.set_Variable("count", intCount.ToString());
            }
        }

        public void Set_PositionDecrement(int intCount)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttPositionDecrement;
            if (intCount == 1)
            {
                this.set_Variable("count", "");
            }
            else
            {
                this.set_Variable("count", intCount.ToString());
            }
        }

        public void Set_PositionIncrement(int intCount)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttPositionIncrement;
            if (intCount == 1)
            {
                this.set_Variable("count", "");
            }
            else
            {
                this.set_Variable("count", intCount.ToString());
            }
        }

        public void Set_RemoveBoundingQuotes()
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttRemoveBoundingQuotes;
        }

        public void Set_RemoveControlCharacters()
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttRemoveControlCharacters;
        }

        public void Set_Replace(string strFrom, string strTo, int intCount)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttReplace;
            this.set_Variable("from", strFrom);
            this.set_Variable("to", strTo);
        }

        public void Set_Restore()
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttRestore;
        }

        public void Set_StripHTML()
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttStripHTML;
        }

        public void Set_TextBetween(string strFrom, string strTo)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttTextBetween;
            this.set_Variable("from", strFrom);
            this.set_Variable("to", strTo);
        }

        public void Set_TextIfBlank(string strText)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttTextIfBlank;
            this.set_Variable("text", strText);
        }

        public void Set_TextTo(string strText)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttTextTo;
            this.set_Variable("text", strText);
        }

        public void Set_TextToReverse(string strText)
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttTextToReverse;
            this.set_Variable("text", strText);
        }

        public void Set_Trim()
        {
            this.ClearVariables();
            this._ActionType = ETransformType.ttTrim;
        }

        public ETransformType ActionType
        {
            get
            {
                return this._ActionType;
            }
            set
            {
                this._ActionType = value;
                switch (this._ActionType)
                {
                    case ETransformType.ttStripHTML:
                        this.Init_StripHTML();
                        break;

                    case ETransformType.ttReplace:
                        this.Init_Replace();
                        break;

                    case ETransformType.ttPositionAt:
                        this.Init_PositionAt();
                        break;

                    case ETransformType.ttPositionAtReverse:
                        this.Init_PositionAtReverse();
                        break;

                    case ETransformType.ttPositionAfter:
                        this.Init_PositionAfter();
                        break;

                    case ETransformType.ttPositionAfterReverse:
                        this.Init_PositionAfterReverse();
                        break;

                    case ETransformType.ttCutTo:
                        this.Init_CutTo();
                        break;

                    case ETransformType.ttCutToReverse:
                        this.Init_CutToReverse();
                        break;

                    case ETransformType.ttCut:
                        this.Init_Cut();
                        break;

                    case ETransformType.ttCutReverse:
                        this.Init_CutReverse();
                        break;

                    case ETransformType.ttCopyTo:
                        this.Init_CopyTo();
                        break;

                    case ETransformType.ttCopyToReverse:
                        this.Init_CopyToReverse();
                        break;

                    case ETransformType.ttCopy:
                        this.Init_Copy();
                        break;

                    case ETransformType.ttCopyReverse:
                        this.Init_CopyReverse();
                        break;

                    case ETransformType.ttPaste:
                        this.Init_Paste();
                        break;

                    case ETransformType.ttInsert:
                        this.Init_Insert();
                        break;

                    case ETransformType.ttTextTo:
                        this.Init_TextTo();
                        break;

                    case ETransformType.ttTextToReverse:
                        this.Init_TextToReverse();
                        break;

                    case ETransformType.ttTextBetween:
                        this.Init_TextBetween();
                        break;

                    case ETransformType.ttTrim:
                        this.Init_Trim();
                        break;

                    case ETransformType.ttRemoveBoundingQuotes:
                        this.Init_RemoveBoundingQuotes();
                        break;

                    case ETransformType.ttRemoveControlCharacters:
                        this.Init_RemoveControlCharacters();
                        break;

                    case ETransformType.ttPositionIncrement:
                        this.Init_PositionIncrement();
                        break;

                    case ETransformType.ttPositionDecrement:
                        this.Init_PositionDecrement();
                        break;

                    case ETransformType.ttTextIfBlank:
                        this.Init_TextIfBlank();
                        break;

                    case ETransformType.ttRestore:
                        this.Init_Restore();
                        break;

                    case ETransformType.ttFormatDate:
                        this.Init_FormatDate();
                        break;

                    case ETransformType.ttDateDifference:
                        this.Init_DateDifference();
                        break;

                    case ETransformType.ttInsertTodaysDate:
                        this.Init_InsertTodaysDate();
                        break;

                    case ETransformType.ttConvertFilesizeToMB:
                        this.Init_ConvertFilesizeToMB();
                        break;

                    case ETransformType.ttErrorHandler:
                        this.Init_ErrorHandler();
                        break;

                    case ETransformType.ttAddValue:
                        this.Init_AddValue();
                        break;
                }
            }
        }

        public string Description
        {
            get
            {
                string str2;
                switch (this._ActionType)
                {
                    case ETransformType.ttStripHTML:
                        return modGlobal.TransformName_StripHTML[0];

                    case ETransformType.ttReplace:
                        return modGlobal.TransformName_Replace[0];

                    case ETransformType.ttPositionAt:
                        return modGlobal.TransformName_PositionAt[0];

                    case ETransformType.ttPositionAtReverse:
                        return modGlobal.TransformName_PositionAtReverse[0];

                    case ETransformType.ttPositionAfter:
                        return modGlobal.TransformName_PositionAfter[0];

                    case ETransformType.ttPositionAfterReverse:
                        return modGlobal.TransformName_PositionAfterReverse[0];

                    case ETransformType.ttPositionAtStart:
                    case ETransformType.ttPositionAtEnd:
                        return str2;

                    case ETransformType.ttCutTo:
                        return modGlobal.TransformName_CutTo[0];

                    case ETransformType.ttCutToReverse:
                        return modGlobal.TransformName_CutToReverse[0];

                    case ETransformType.ttCut:
                        return modGlobal.TransformName_Cut[0];

                    case ETransformType.ttCutReverse:
                        return modGlobal.TransformName_CutReverse[0];

                    case ETransformType.ttCopyTo:
                        return modGlobal.TransformName_CopyTo[0];

                    case ETransformType.ttCopyToReverse:
                        return modGlobal.TransformName_CopyToReverse[0];

                    case ETransformType.ttCopy:
                        return modGlobal.TransformName_Copy[0];

                    case ETransformType.ttCopyReverse:
                        return modGlobal.TransformName_CopyReverse[0];

                    case ETransformType.ttPaste:
                        return modGlobal.TransformName_Paste[0];

                    case ETransformType.ttInsert:
                        return modGlobal.TransformName_Insert[0];

                    case ETransformType.ttTextTo:
                        return modGlobal.TransformName_TextTo[0];

                    case ETransformType.ttTextToReverse:
                        return modGlobal.TransformName_TextToReverse[0];

                    case ETransformType.ttTextBetween:
                        return modGlobal.TransformName_TextBetween[0];

                    case ETransformType.ttTrim:
                        return modGlobal.TransformName_Trim[0];

                    case ETransformType.ttRemoveBoundingQuotes:
                        return modGlobal.TransformName_RemoveBoundingQuotes[0];

                    case ETransformType.ttRemoveControlCharacters:
                        return modGlobal.TransformName_RemoveControlCharacters[0];

                    case ETransformType.ttPositionIncrement:
                        return modGlobal.TransformName_PositionIncrement[0];

                    case ETransformType.ttPositionDecrement:
                        return modGlobal.TransformName_PositionDecrement[0];

                    case ETransformType.ttTextIfBlank:
                        return modGlobal.TransformName_TextIfBlank[0];

                    case ETransformType.ttRestore:
                        return modGlobal.TransformName_Restore[0];

                    case ETransformType.ttFormatDate:
                        return modGlobal.TransformName_FormatDate[0];

                    case ETransformType.ttDateDifference:
                        return modGlobal.TransformName_DateDifference[0];

                    case ETransformType.ttInsertTodaysDate:
                        return modGlobal.TransformName_InsertTodaysDate[0];

                    case ETransformType.ttConvertFilesizeToMB:
                        return modGlobal.TransformName_ConvertFilesizeToMB[0];

                    case ETransformType.ttErrorHandler:
                        return modGlobal.TransformName_ErrorHandler[0];

                    case ETransformType.ttAddValue:
                        return modGlobal.TransformName_AddValue[0];
                }
                return str2;
            }
            set
            {
                string sLeft = value;
                if (StringType.StrCmp(sLeft, modGlobal.TransformName_StripHTML[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttStripHTML;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Replace[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttReplace;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_PositionAt[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttPositionAt;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_PositionAtReverse[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttPositionAtReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_PositionAfter[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttPositionAfter;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_PositionAfterReverse[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttPositionAfterReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Cut[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttCut;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_CutReverse[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttCutReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_CutTo[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttCutTo;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_CutToReverse[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttCutToReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Copy[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttCopy;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_CopyReverse[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttCopyReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_CopyTo[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttCopyTo;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_CopyToReverse[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttCopyToReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Paste[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttPaste;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Insert[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttInsert;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_TextTo[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttTextTo;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_TextToReverse[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttTextToReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_TextBetween[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttTextBetween;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Trim[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttTrim;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_RemoveBoundingQuotes[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttRemoveBoundingQuotes;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_RemoveControlCharacters[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttRemoveControlCharacters;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_PositionIncrement[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttPositionIncrement;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_PositionDecrement[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttPositionDecrement;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_TextIfBlank[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttTextIfBlank;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Restore[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttRestore;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_FormatDate[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttFormatDate;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_DateDifference[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttDateDifference;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_InsertTodaysDate[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttInsertTodaysDate;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_ConvertFilesizeToMB[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttConvertFilesizeToMB;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_ErrorHandler[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttErrorHandler;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_AddValue[0], false) == 0)
                {
                    this.ActionType = ETransformType.ttAddValue;
                }
            }
        }

        public string Name
        {
            get
            {
                string str2;
                switch (this._ActionType)
                {
                    case ETransformType.ttStripHTML:
                        return modGlobal.TransformName_StripHTML[1];

                    case ETransformType.ttReplace:
                        return modGlobal.TransformName_Replace[1];

                    case ETransformType.ttPositionAt:
                        return modGlobal.TransformName_PositionAt[1];

                    case ETransformType.ttPositionAtReverse:
                        return modGlobal.TransformName_PositionAtReverse[1];

                    case ETransformType.ttPositionAfter:
                        return modGlobal.TransformName_PositionAfter[1];

                    case ETransformType.ttPositionAfterReverse:
                        return modGlobal.TransformName_PositionAfterReverse[1];

                    case ETransformType.ttPositionAtStart:
                    case ETransformType.ttPositionAtEnd:
                        return str2;

                    case ETransformType.ttCutTo:
                        return modGlobal.TransformName_CutTo[1];

                    case ETransformType.ttCutToReverse:
                        return modGlobal.TransformName_CutToReverse[1];

                    case ETransformType.ttCut:
                        return modGlobal.TransformName_Cut[1];

                    case ETransformType.ttCutReverse:
                        return modGlobal.TransformName_CutReverse[1];

                    case ETransformType.ttCopyTo:
                        return modGlobal.TransformName_CopyTo[1];

                    case ETransformType.ttCopyToReverse:
                        return modGlobal.TransformName_CopyToReverse[1];

                    case ETransformType.ttCopy:
                        return modGlobal.TransformName_Copy[1];

                    case ETransformType.ttCopyReverse:
                        return modGlobal.TransformName_CopyReverse[1];

                    case ETransformType.ttPaste:
                        return modGlobal.TransformName_Paste[1];

                    case ETransformType.ttInsert:
                        return modGlobal.TransformName_Insert[1];

                    case ETransformType.ttTextTo:
                        return modGlobal.TransformName_TextTo[1];

                    case ETransformType.ttTextToReverse:
                        return modGlobal.TransformName_TextToReverse[1];

                    case ETransformType.ttTextBetween:
                        return modGlobal.TransformName_TextBetween[1];

                    case ETransformType.ttTrim:
                        return modGlobal.TransformName_Trim[1];

                    case ETransformType.ttRemoveBoundingQuotes:
                        return modGlobal.TransformName_RemoveBoundingQuotes[1];

                    case ETransformType.ttRemoveControlCharacters:
                        return modGlobal.TransformName_RemoveControlCharacters[1];

                    case ETransformType.ttPositionIncrement:
                        return modGlobal.TransformName_PositionIncrement[1];

                    case ETransformType.ttPositionDecrement:
                        return modGlobal.TransformName_PositionDecrement[1];

                    case ETransformType.ttTextIfBlank:
                        return modGlobal.TransformName_TextIfBlank[1];

                    case ETransformType.ttRestore:
                        return modGlobal.TransformName_Restore[1];

                    case ETransformType.ttFormatDate:
                        return modGlobal.TransformName_FormatDate[1];

                    case ETransformType.ttDateDifference:
                        return modGlobal.TransformName_DateDifference[1];

                    case ETransformType.ttInsertTodaysDate:
                        return modGlobal.TransformName_InsertTodaysDate[1];

                    case ETransformType.ttConvertFilesizeToMB:
                        return modGlobal.TransformName_ConvertFilesizeToMB[1];

                    case ETransformType.ttErrorHandler:
                        return modGlobal.TransformName_ErrorHandler[1];

                    case ETransformType.ttAddValue:
                        return modGlobal.TransformName_AddValue[1];
                }
                return str2;
            }
            set
            {
                string sLeft = value;
                if (StringType.StrCmp(sLeft, modGlobal.TransformName_StripHTML[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttStripHTML;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Replace[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttReplace;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_PositionAt[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttPositionAt;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_PositionAtReverse[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttPositionAtReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_PositionAfter[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttPositionAfter;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_PositionAfterReverse[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttPositionAfterReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Cut[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttCut;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_CutReverse[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttCutReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_CutTo[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttCutTo;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_CutToReverse[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttCutToReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Copy[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttCopy;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_CopyReverse[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttCopyReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_CopyTo[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttCopyTo;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_CopyToReverse[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttCopyToReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Paste[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttPaste;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Insert[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttInsert;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_TextTo[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttTextTo;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_TextToReverse[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttTextToReverse;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_TextBetween[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttTextBetween;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Trim[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttTrim;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_RemoveBoundingQuotes[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttRemoveBoundingQuotes;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_RemoveControlCharacters[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttRemoveControlCharacters;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_PositionIncrement[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttPositionIncrement;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_PositionDecrement[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttPositionDecrement;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_TextIfBlank[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttTextIfBlank;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_Restore[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttRestore;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_FormatDate[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttFormatDate;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_DateDifference[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttDateDifference;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_InsertTodaysDate[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttInsertTodaysDate;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_ConvertFilesizeToMB[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttConvertFilesizeToMB;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_ErrorHandler[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttErrorHandler;
                }
                else if (StringType.StrCmp(sLeft, modGlobal.TransformName_AddValue[1], false) == 0)
                {
                    this.ActionType = ETransformType.ttAddValue;
                }
            }
        }

        public int NumVariables
        {
            get
            {
                return this._Variables.Count;
            }
        }

        public string this[int intIndex]
        {
            get
            {
                return this._Variables[intIndex];
            }
            set
            {
                this._Variables[this.get_VariableName(intIndex)] = value;
            }
        }

        public string this[string strValue]
        {
            get
            {
                return this._Variables[strValue];
            }
            set
            {
                this._Variables[strValue] = value;
            }
        }

        public enum ETransformType
        {
            ttStripHTML,
            ttReplace,
            ttPositionAt,
            ttPositionAtReverse,
            ttPositionAfter,
            ttPositionAfterReverse,
            ttPositionAtStart,
            ttPositionAtEnd,
            ttCutTo,
            ttCutToReverse,
            ttCut,
            ttCutReverse,
            ttCopyTo,
            ttCopyToReverse,
            ttCopy,
            ttCopyReverse,
            ttPaste,
            ttInsert,
            ttTextTo,
            ttTextToReverse,
            ttTextBetween,
            ttTrim,
            ttRemoveBoundingQuotes,
            ttRemoveControlCharacters,
            ttPositionIncrement,
            ttPositionDecrement,
            ttTextIfBlank,
            ttRestore,
            ttFormatDate,
            ttDateDifference,
            ttInsertTodaysDate,
            ttConvertFilesizeToMB,
            ttErrorHandler,
            ttAddValue
        }
    }
}

