﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using System;
    using System.Collections;

    public class CTextTransforms
    {
        public Collection TransformsCollection;

        public CTextTransforms()
        {
            this.TransformsCollection = new Collection();
        }

        public CTextTransforms(CXMLNode oXMLNode)
        {
            this.TransformsCollection = new Collection();
            this.Load(oXMLNode);
        }

        public void Load(CXMLNode oXMLNode)
        {
            IEnumerator enumerator;
            this.TransformsCollection = new Collection();
            try
            {
                enumerator = oXMLNode.ChildNodes.GetEnumerator();
                while (enumerator.MoveNext())
                {
                    oXMLNode = (CXMLNode) enumerator.Current;
                    CTextTransform item = new CTextTransform();
                    item.Load(oXMLNode);
                    this.TransformsCollection.Add(item, null, null, null);
                }
            }
            finally
            {
                if (enumerator is IDisposable)
                {
                    ((IDisposable) enumerator).Dispose();
                }
            }
        }

        public void Save(CXMLNode oXMLNode)
        {
            IEnumerator enumerator;
            try
            {
                enumerator = this.TransformsCollection.GetEnumerator();
                while (enumerator.MoveNext())
                {
                    ((CTextTransform) enumerator.Current).Save(oXMLNode);
                }
            }
            finally
            {
                if (enumerator is IDisposable)
                {
                    ((IDisposable) enumerator).Dispose();
                }
            }
        }

        public string Transform(string strData)
        {
            int intPos = 0;
            string strClipboard = "";
            bool flag = false;
            string str2 = strData;
            foreach (CTextTransform transform in this.TransformsCollection)
            {
                if (flag)
                {
                    flag = transform.ActionType != CTextTransform.ETransformType.ttErrorHandler;
                }
                else
                {
                    if (transform.ActionType == CTextTransform.ETransformType.ttErrorHandler)
                    {
                        break;
                    }
                    if (transform.ActionType == CTextTransform.ETransformType.ttRestore)
                    {
                        strData = str2;
                        intPos = 0;
                        continue;
                    }
                    flag = !transform.Perform(ref strData, ref intPos, ref strClipboard);
                }
            }
            if (flag)
            {
                return "";
            }
            return strData;
        }
    }
}

