﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using Microsoft.VisualBasic.CompilerServices;
    using System;
    using System.Diagnostics;
    using System.Xml;

    public class CUpdate
    {
        private string _URL;
        public string Filename;
        public Collection UpdateEngines;
        public string URL;
        public string Version;
        public string WhatsNew;
        private XmlDocument xmlDoc = new XmlDocument();

        public string FullURL(string strRelativeURL)
        {
            if (strRelativeURL == null)
            {
                strRelativeURL = "";
            }
            if (strRelativeURL.IndexOf("://") == -1)
            {
                string str2 = this._URL;
                if (str2.EndsWith("/"))
                {
                    str2 = str2.Substring(0, str2.Length - 1);
                }
                if (strRelativeURL.StartsWith("/"))
                {
                    strRelativeURL = strRelativeURL.Substring(1);
                }
                if (strRelativeURL.StartsWith(":"))
                {
                    strRelativeURL = str2 + strRelativeURL;
                }
                else
                {
                    strRelativeURL = str2 + "/" + strRelativeURL;
                }
            }
            return strRelativeURL;
        }

        public bool Load(string strURL)
        {
            bool flag;
            this._URL = strURL;
            try
            {
                if (modGlobal.Download("Update Definitions", this._URL + "/" + modGlobal.UpdatesFilename, modGlobal.UpdatesFilename, modGlobal.TempFolder, ""))
                {
                    this.UpdateEngines = new Collection();
                    CXMLNode node = new CXMLNode(modGlobal.TempFolder + modGlobal.UpdatesFilename);
                    node = node.SelectNode("updates");
                    foreach (CXMLNode node in node.ChildNodes)
                    {
                        string name = node.Name;
                        if (StringType.StrCmp(name, "engine", false) == 0)
                        {
                            CUpdateEngine item = new CUpdateEngine();
                            item.URL = this.FullURL(node.get_StringAttribute("url", ""));
                            item.Name = node.get_StringAttribute("name", "");
                            item.Filename = node.get_StringAttribute("filename", "");
                            item.EngineDate = modGlobal.ConvDateWithMask(node.get_StringAttribute("date", ""), "yyyyMMdd", new DateTime(0x8aab5b7044c8000L));
                            item.Version = node.get_StringAttribute("version", "");
                            if (StringType.StrCmp(item.Version, "0.7b", false) == 0)
                            {
                                if (item.Engine == null)
                                {
                                    this.UpdateEngines.Add(item, null, null, null);
                                }
                                else if (DateTime.Compare(item.Engine.EngineDate, item.EngineDate) == -1)
                                {
                                    this.UpdateEngines.Add(item, null, null, null);
                                }
                            }
                            continue;
                        }
                        if (StringType.StrCmp(name, "program", false) == 0)
                        {
                            this.Version = node.get_StringAttribute("version", "");
                            this.URL = this.FullURL(node.get_StringAttribute("url", ""));
                            this.Filename = node.get_StringAttribute("filename", "");
                            this.WhatsNew = modGlobal.g_oStrings.ConvertCRLF(node.TextValue);
                        }
                        else
                        {
                            return false;
                        }
                    }
                    return true;
                }
                flag = false;
            }
            catch (Exception exception1)
            {
                ProjectData.SetProjectError(exception1);
                Exception exception = exception1;
                flag = false;
                ProjectData.ClearProjectError();
                return flag;
                ProjectData.ClearProjectError();
            }
            return flag;
        }

        public void Update()
        {
            if (modGlobal.Download("Torrent Harvester Version " + this.Version, this.URL, this.Filename, modGlobal.TempFolder, "") && (Interaction.MsgBox("Torrent Harvester Version " + this.Version + " has been downloaded to " + modGlobal.TempFolder + ". Do you want to install this now?", MsgBoxStyle.YesNo, "Install Torrent Harvester") == MsgBoxResult.Yes))
            {
                Process.Start(modGlobal.TempFolder + this.Filename);
                ProjectData.EndApp();
            }
        }
    }
}

