﻿namespace TorrentHarvester
{
    using Microsoft.VisualBasic;
    using Microsoft.VisualBasic.CompilerServices;
    using System;
    using System.Collections.Specialized;
    using System.Runtime.InteropServices;
    using System.Xml;

    public class CXMLNode
    {
        public Collection m_ChildNodes;
        private XmlNode _xmlNode;

        public CXMLNode()
        {
            this._xmlNode = new XmlDocument();
        }

        public CXMLNode(string strFilename)
        {
            this._xmlNode = modGlobal.LoadXMLFile(strFilename);
        }

        public CXMLNode(XmlNode xmlNode)
        {
            this._xmlNode = xmlNode;
        }

        public void AddAttribute(string strName, string strValue, [Optional, DefaultParameterValue(false)] bool bAllowBlank)
        {
            if (bAllowBlank | (StringType.StrCmp(strValue, "", false) != 0))
            {
                XmlAttribute node = this._xmlDoc.CreateAttribute(strName);
                node.Value = strValue;
                this._xmlNode.Attributes.SetNamedItem(node);
            }
        }

        public CXMLNode Create(string strName)
        {
            XmlNode newChild = this._xmlDoc.CreateElement(strName);
            this._xmlNode.AppendChild(newChild);
            return new CXMLNode(newChild);
        }

        public void CreateText(string strName, string strText, [Optional, DefaultParameterValue(false)] bool bAllowBlank)
        {
            if (bAllowBlank | (StringType.StrCmp(strText, "", false) != 0))
            {
                XmlNode newChild = this._xmlDoc.CreateElement(strName);
                XmlText text = this._xmlDoc.CreateTextNode(strText);
                newChild.AppendChild(text);
                this._xmlNode.AppendChild(newChild);
            }
        }

        public void Save(string strFilename)
        {
            this._xmlDoc.Save(strFilename);
        }

        public CXMLNode SelectNode(string strName)
        {
            return new CXMLNode(this._xmlNode.SelectSingleNode(strName));
        }

        private XmlDocument _xmlDoc
        {
            get
            {
                return (XmlDocument) Interaction.IIf(this._xmlNode.OwnerDocument == null, this._xmlNode, this._xmlNode.OwnerDocument);
            }
        }

        public StringCollection AttributeNames
        {
            get
            {
                StringCollection strings2 = new StringCollection();
                foreach (XmlAttribute attribute in this._xmlNode.Attributes)
                {
                    strings2.Add(attribute.Name);
                }
                return strings2;
            }
        }

        public bool this[string strName, bool bDefault]
        {
            get
            {
                return (StringType.StrCmp(this[strName, Interaction.IIf(bDefault, "Y", "N").ToString()].ToUpper(), "Y", false) == 0);
            }
        }

        public Collection ChildNodes
        {
            get
            {
                if (this.m_ChildNodes == null)
                {
                    this.m_ChildNodes = new Collection();
                    if (this._xmlNode != null)
                    {
                        foreach (XmlNode node in this._xmlNode.ChildNodes)
                        {
                            CXMLNode item = new CXMLNode(node);
                            this.m_ChildNodes.Add(item, null, null, null);
                        }
                    }
                }
                return this.m_ChildNodes;
            }
        }

        public int this[string strName, int intDefault]
        {
            get
            {
                return IntegerType.FromString(this[strName, intDefault.ToString()]);
            }
        }
                
        public string Name
        {
            get
            {
                return this._xmlNode.Name;
            }
        }

        public string this[string strName, string strDefault]
        {
            get
            {
                try
                {
                    strDefault = this._xmlNode.Attributes.GetNamedItem(strName).Value;
                }
                catch (Exception exception1)
                {
                    ProjectData.SetProjectError(exception1);
                    ProjectData.ClearProjectError();
                }
                return strDefault;
            }
        }
        
        public string TextValue
        {
            get
            {
                return this._xmlNode.ChildNodes[0].Value;
            }
        }
    }
}

